Lua_BossBasePanel = class("Lua_BossBasePanel", Lua_DisplayObject)
function Lua_BossBasePanel:ctor(p, skin, type)
	self.type = type;
	self.listW = 310;
	self.listH = 480;
	self.listX = 417;
	self.listY = 10;
	self.layer = 3500;
	self:superCall("ctor", p, skin);
end

function Lua_BossBasePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.sGray = false;
	self.curSelectIdx = 1;
	self.needSetIdx = false;
	self.dataList = Array();
	self.selectFirst = true;

	self.attrKeyArr = Array();
	self.attrKeyArr:add("hp");
	self.attrKeyArr:add("attack");
	self.attrKeyArr:add("defense");
	self.attrKeyArr:add("hit");
	self.attrKeyArr:add("avoid");

	DataCenter.bossData.curOpenUIType = self.type;

	self.showingAttr = false;
	self.dropTitleTxt.text = LanUtil.getValue(121649);

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, self.listW, self.listH));
	self.dragList:setLocation(self.listX, self.listY, 0);
	self.dragList:setListCell(Lua_BossListBaseItem, 108, 310, 1);

	self.followChk:addBoxChange(self, self.OnFollowChange);
	self.followChk.seleted = true;

	local desLab;
	self.attrTextcontainer = UICreate.createGameObject(self.content);
	self.attrTextcontainer.name = "attrTextcontainer";
	self.attrTxtList = Array();
	for i = 1, 6 do
		desLab = UICreate.createLabel(self.attrTextcontainer, "", 0, 0, 235, 30, 24);
		desLab.pivot = UIWidget.Pivot.TopLeft;
		desLab:setDepth(self.depth + 10);
		desLab:setLocation(-215 +(((i - 1) % 2) * 243), -90 - math.floor((i - 1) / 2) * 40, -500);
		self.attrTxtList:add(desLab);
	end
	self.attrTextcontainer:SetActive(false);

	self.rItem = Lua_RewardItem.new(self.content);
	self.rItem:setMaxShow(10);
	self.rItem:setLayout(93, 70, 5);
	self.rItem:setDepth(self.depth + 10);
	self.rItem:setClickWin(true);
	self.rItem:setMouseEnble(true);
	self.rItem:setItemScale(0.8, 0.8);
	self.rItem:setLocation(-200, -114, 0);

	self:showOverLvTips(false);

	self.bossAtrrBtn:addClickFuntion(self, self.onAttributeClick);
	self.killRecordBtn:addClickFuntion(self, self.onKilledRecordBtnClick);
	self.ruleIcon:addClickFuntion(self, self.onRuleClick);

	self:addLuaEvent("BOSS_DATA_INFO_UPDATE", self, self.updateDetailInfo);
	self:addLuaEvent("BOSS_LIST_ITEM_CLICK", self, self.onListItemClick);
	-- self:addLuaEvent("SHILED_BOSS_UI_AVATAR", self, self.onShowHideAvatar);
	local cmd = getProtoMsg("Proto10401602");
	cmd.type = self.type;
	sendMsg(10401602, cmd);
end

function Lua_BossBasePanel:onShowHideAvatar(val)
	if self.monsEffect ~= nil then
		self.monsEffect:setEnable(not val);
	end
end

function Lua_BossBasePanel:onRuleClick()
	Lua_MsgUtil.callFunc("SHILED_BOSS_UI_AVATAR", true);
end

function Lua_BossBasePanel:updateDetailInfo(type)
	if type ~= self.type then
		return;
	end

	self.listData = DataCenter.bossData:getBossDetailByType(type);
	self.dataList:clear();

	local configInfo;
	if type == Lua_BossData.TYPE_ISLE_BOSS then
		self.dataList:sort("lvl", false);
		local list1 = Array();
		local list2 = Array();
		local list3 = Array();
		for k, v in ipairs(self.listData.bossDetailSet) do
			configInfo = getConfig({"monster", v.monster_id});
			if configInfo.monster_type == nil or configInfo.monster_type == 0 then
				list2:add(v);
			elseif configInfo.monster_type >= 1 and configInfo.monster_type <= 9 then
				list1:add(v);
			elseif configInfo.monster_type >= 101 then
				list3:add(v);
			end
		end

		for i = 1, list1:getSize() do
			self.dataList:add(list1[i]);
		end

		for i = 1, list2:getSize() do
			self.dataList:add(list2[i]);
		end

		-- boss按等级排序
		list3:sort("lvl", false);
		for i = 1, list3:getSize() do
			self.dataList:add(list3[i]);
		end
	elseif type == Lua_BossData.TYPE_ISLEBOSS_KUAFU  then
		self.layerDataDic = {};
		for k,v in ipairs(self.listData.bossDetailSet) do
			if self.layerDataDic[tostring(v.layer)] == nil then
				self.layerDataDic[tostring(v.layer)] = Array();
			end
			self.layerDataDic[tostring(v.layer)]:add(v);
		end

		for i,v in pairs(self.layerDataDic) do
			if v ~= nil then
				local list1 = Array();
				local list2 = Array();
				local list3 = Array();
				local dataList = Array();
				for j = 1, v:getSize() do
					configInfo = getConfig( { "monster", self.layerDataDic[i][j].monster_id });
					if configInfo.monster_type == nil or configInfo.monster_type == 0 then
						list2:add(self.layerDataDic[i][j]);
					elseif configInfo.monster_type >= 1 and configInfo.monster_type <= 9 then
						list1:add(self.layerDataDic[i][j]);
					elseif configInfo.monster_type >= 101 then
						list3:add(self.layerDataDic[i][j]);
					end
				end

				for k = 1, list1:getSize() do
					dataList:add(list1[k]);
				end

				for l = 1, list2:getSize() do
					dataList:add(list2[l]);
				end

				list3:sort("lvl", false);
				for n = 1, list3:getSize() do
					dataList:add(list3[n]);
				end
				self.layerDataDic[tostring(i)]=dataList;
			end
		end
	else
		for k, v in ipairs(self.listData.bossDetailSet) do
			-- ProtoBossDetail  优化12060
			-- 优化12060  boss等级改为boss所在场景最低等级
			if self.type == Lua_BossData.TYPE_WILD then
				local secen_id = getConfig({"monster", v.monster_id, "scene_id"});
				local sceneMinLevel = 0
				local sceneData = Lua_SceneConfigData.getSceneConfig(secen_id)
				if secen_id ~= nil then
					if sceneData ~= nil then
						sceneMinLevel = sceneData.config.level[1];
					end
				end

				if DataCenter.roleData.level >= sceneMinLevel then
					self.dataList:add(v)
				end
			else
				self.dataList:add(v);
			end
		end
	end

	if type == Lua_BossData.TYPE_WILD then
		-- 野外boss要按等级排序
		self.dataList:sort("lvl", false);
	end

	local curSelectedIdx
	if self.selectFirst == false then
		curSelectedIdx = self.dragList.curSelectedIdx;
	end

	if type == Lua_BossData.TYPE_ISLEBOSS_KUAFU then
		self.dragList:setLuaArrayData(self.layerDataDic[tostring(self.curSelectIdx)], true);
	else
		self.dragList:setLuaArrayData(self.dataList, true);
	end

	if DataCenter.bossData.checkBossId ~= nil then
		self:getMonsterIdLayer(DataCenter.bossData.checkBossId);
		self.needSetIdx = true;
		DataCenter.bossData.checkBossId = nil;
	end

	if self.selectFirst == true then
		if self.monsterIndex == nil then
			self.monsterIndex = 1;
		end
		self.dragList:moveToIndex(self.monsterIndex, true);
		self.dragList:setSelected(self.monsterIndex);
		self.selectFirst = false;
	else
		self.dragList:setSelected(curSelectedIdx);
	end

	if type == Lua_BossData.TYPE_ISLEBOSS_KUAFU then
		if self.listData.start_time == nil or self.listData.start_time == 0 then
			self.ruleTxt:setEnable(true);
			self.ruleTxt.text = LanUtil.getValue(121664)
			if self.allotBtn ~= nil then
				self.allotBtn:setEnable(false);
			end
		else
			self.ruleTxt:setEnable(false);
			if self.allotBtn == nil then
				self.allotBtn = UICreate.createButton(self.content, LanUtil.getValue(128637), -301, -307, 141, 54);
				self.allotBtn.txt.colorStr = "4285803520";
				self.allotBtn.txt:SetDimensions(100, 30);
				self.allotBtn.txt.fontSize = 24;
				self.allotBtn:addClickFuntion(self, self.onEnterBtnClick);
				self.allotBtn:setDepth(10);
			else
				self.allotBtn:setEnable(true);
			end
		end
	else
		self.ruleTxt:setEnable(true);
		self.ruleTxt.text = LanUtil.getValue(121664)
		if self.allotBtn ~= nil then
			self.allotBtn:setEnable(false);
		end
	end
end

function Lua_BossBasePanel:onEnterBtnClick()
	local startTime = TimeTransform.getInstance():transSeconds8(self.listData.start_time, "MM-dd HH:mm");
	local endTime = TimeTransform.getInstance():transSeconds8(self.listData.end_time, "MM-dd HH:mm");
	local tipData = {};
	tipData.des = LanUtil.formateStr(LanUtil.getValue(121666), tostring(startTime), tostring(endTime));
	tipData.owner = self;
	tipData.subFun = self.onSubCallback;
	tipData.type = 2;
	Lua_WindowUtil.openWin("Lua_TipsWindow", WinParam.ACTION_OPEN, tipData);
end

function Lua_BossBasePanel:onSubCallback()
end

function Lua_BossBasePanel:getMonsterIdLayer(monsterId)
	-- 用于图鉴功能--通过bossID 让光标移到对应boss
	local len = tonumber(self.dataList:getSize())
	if len ~= 0 then
		for i = 1, self.dataList:getSize() do
			if self.dataList[i].monster_id == monsterId then
				self.monsterIndex = i;
				break;
			end
		end
	end
end

function Lua_BossBasePanel:onListItemClick(itemData)
	if self.isDispose_2 == true then
		return;
	end

	self.itemData = itemData;
	self.curCfg = getConfig({"monster", itemData.monster_id});
	if self.curCfg ~= nil then
		if self.curCfg.jid ~= nil then
			local effectUrl = "/model/" .. tostring(self.curCfg.jid);
			if self.monsEffect == nil then
				self.monsEffect = UICreate.createUIEffect(self.content, effectUrl, self.curCfg.jid, 0, 0);
			else
				if effectUrl ~= self.curEffectUrl then
					self.monsEffect:setUrl(effectUrl, self.curCfg.jid);
				end
			end

			self.curEffectUrl = effectUrl;
			self.monsEffect:setSacle(1, 1, 1);
			local px = 0;
			local py = 0;
			local pz = 0;
			if self.curCfg.jid_ui_offset ~= nil then
				px = px + self.curCfg.jid_ui_offset[1];
				py = py + self.curCfg.jid_ui_offset[2];
				pz = pz + self.curCfg.jid_ui_offset[3];
			end
			self.monsEffect:setLocation(px, py, pz);
			self.monsEffect:SetRenderQueue(self.infoBg, 2, 2);

			if self.curCfg.jid_ui_rotation ~= nil then
				local rot = self.curCfg.jid_ui_rotation;
				self.monsEffect:setRot(rot[1], rot[2], rot[3]);
			end

			if self.curCfg.jid_ui_scale ~= nil then
				local scl = self.curCfg.jid_ui_scale;
				self.monsEffect:setSacle(scl[1], scl[2], scl[3]);
			end
			self.monsEffect:setRotEnable(true, -48, 90, 300, 260, self.depth + 10);
		end

		self.nameTxt.text = self.curCfg.name;
		if self.curCfg.born_scene_desc ~= nil then
			self.bornTxt.text = LanUtil.getValue(121651) .. self.curCfg.born_scene_desc;
		end

		self.followChk.seleted = self.itemData.is_follow == 1 and true or false;
		local nreward;
		if self.curCfg.show_reward ~= nil then
			nreward = self.curCfg.show_reward;
		else
			nreward = self.curCfg.drop_reward;
		end

		if nreward ~= nil then
			if self.showReward ~= nreward then
				self.showReward = nreward;
				self.rItem:setRewardByRewardList(Array(nreward));
			end
		end

		local attrList = Array();
		local keyLen = self.attrKeyArr:getSize();
		for i = 1, keyLen do
			local tkey = self.attrKeyArr[i];
			self.attrTxtList[i].text = "";
			if self.curCfg[tkey] ~= nil then
				local tvalue = tostring(self.curCfg[tkey]);
				local attrLb = tostring(Lua_ThingDefine.getParamName(tkey));
				self.attrTxtList[i].text = "[FFB319]" .. attrLb .. "：[-] [D2D8DC]" .. tvalue .. "[-]";
			end
		end
	else
		print("no config monster_id " .. tostring(itemData.monster_id));
	end

	local compareLv = 0;
	if self.curCfg.limit_level ~= nil then
		compareLv = self.curCfg.limit_level;
	end

	self.tipsTxt.text = LanUtil.formateStr(LanUtil.getValue(121638), tostring(compareLv));
	self:showOverLvTips(compareLv > 0 and DataCenter.roleData.level - self.itemData.lvl >= compareLv);
end

function Lua_BossBasePanel:doSendEnterBossScene()
end

function Lua_BossBasePanel:showOverLvTips(val)
	self.tipsBg:setEnable(val);
	self.tipsTxt:setEnable(val);
end

function Lua_BossBasePanel:OnFollowChange(val)
	if self.itemData ~= nil then
		local isFollow = val == true and 1 or 0;
		DataCenter.bossData:sFollowBossRelive(self.type, self.itemData.monster_id, isFollow);
	end
end

function Lua_BossBasePanel:onAttributeClick(go)
	self.showingAttr = not self.showingAttr;
	self.bossAtrrBtn:setAltas("boss_atlas", self.showingAttr == true and "ui_boss_icon_4" or "ui_boss_icon_2");
	self.bossAtrrBtn:resetSize();

	self.attrTextcontainer:SetActive(self.showingAttr);
	self.rItem:setEnable(not self.showingAttr);

	self.dropTitleTxt.text = self.showingAttr == true and LanUtil.getValue(121650) or LanUtil.getValue(121649);
end

function Lua_BossBasePanel:onKilledRecordBtnClick(go)
	if self.itemData ~= nil then
		Lua_WindowUtil.openWin("Lua_BossKilledRecordWindow", WinParam.ACTION_OPEN, { type = self.type, monster_id = self.itemData.monster_id });
	end
end

function Lua_BossBasePanel:dispose()
	if self.monsEffect ~= nil then
		self.monsEffect:dispose();
		self.monsEffect = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_BossListBaseItem = class("Lua_BossListBaseItem", Lua_ListCell)
function Lua_BossListBaseItem:ctor(p)
	self:superCall("ctor", p, "PersonalBossListItem_skin");
end

function Lua_BossListBaseItem:buildShowItem()
	self:superCall("buildShowItem");

	self.iskilled = false;

	self.followedMark = Lua_MarkItem.new(self.content, "common_atlas_2", "ui_common_tishi2", LanUtil.getValue(121622), 18, Color.New(1, 1, 1, 1), 0, Lua_ColorDefine.transColor("ffffff"));
	self.followedMark.content.name = "followedMark";
	self.followedMark:setDepth(self.depth + 10);
	self.followedMark:setBgSize(86, 46);
	self.followedMark:setLocation(96, 18, 0);
	self.followedMark:setEnable(false);

	self.followedMark2 = Lua_MarkItem.new(self.content, "common_atlas_2", "ui_common_tishi2", LanUtil.getValue(121622), 18, Color.New(1, 1, 1, 1), 0, Lua_ColorDefine.transColor("ffffff"));
	self.followedMark2.content.name = "followedMark2";
	self.followedMark2:setDepth(self.depth + 10);
	self.followedMark2:setBgSize(86, 46);
	self.followedMark2:setLocation(-40, 18, 0);
	self.followedMark2:setEnable(true);

	self.mark:setEnable(false);
	self.killedTxt:setEnable(false);
	self.countDownTxt:setEnable(false);

	self:setGradeShow(false);
	self:setKilled(false);
end

function Lua_BossListBaseItem:setData(val)
	self.data = val;
	self.cfg = getConfig({"monster", val.monster_id});

	if self.cfg ~= nil then
		local colorStr = "[FFFFFF]";
		local myLv = DataCenter.roleData.level;
		-- BUG #7680 【个人boss】玩法优化 1）等级比玩家高的boss，界面ui的名字和等级呈红色
		if DataCenter.bossData.curOpenUIType == Lua_BossData.TYPE_PERSONAL then
			local sceneCfg = Lua_SceneConfigData.getSceneConfig(90201);
			if sceneCfg.config.monster ~= nil then
				local monsterList = sceneCfg.config.monster;
				local monsCfg = nil;
				for i, v in ipairs(monsterList) do
					if tonumber(v.id) == tonumber(val.monster_id) then
						monsCfg = v;
						break;
					end
				end

				if monsCfg ~= nil and monsCfg.enter_lvl > myLv then
					-- 人物等级还没达到可挑战等级，显示红色，表示不能挑战
					colorStr = "[FF1616]";
				end
			end
		end

		if DataCenter.bossData.curOpenUIType == Lua_BossData.TYPE_ISLE_BOSS or DataCenter.bossData.curOpenUIType == Lua_BossData.TYPE_ISLEBOSS_KUAFU or DataCenter.bossData.curOpenUIType == Lua_BossData.TYPE_PRIMITIVE_KUAFU then
			-- type: 0：小怪，1~9：采集物，大于100：boss
			if self.cfg.monster_type == nil or self.cfg.monster_type == 0 or self.cfg.monster_type >= 1 and self.cfg.monster_type <= 9 then
				if self.nameTxtBg == nil then
					self.nameTxtBg = UICreate.createUIAtlasImage(self.content, "boss_atlas", "ui_boss_bg_3", -152, 30, 212, 32);
					self.nameTxtBg.name = "nameTxtBg";
					self.nameTxtBg.pivot = UIWidget.Pivot.Left;
					self.nameTxtBg:setDepth(2);
				else
					self.nameTxtBg:setEnable(true);
				end
				self.bossNameTxt.text = colorStr .. self.cfg.name;
				self.bossNameTxt:setLocation(-130, 30, 0);

				self:setKilled(true);
			elseif self.cfg.monster_type >= 101 then
				self.bossNameTxt.text = colorStr .. "Lv." .. tostring(self.data.lvl) .. " " .. self.cfg.name;
				self.bossNameTxt:setLocation(-130, -25, 0);
			
				if self.nameTxtBg ~= nil then
					self.nameTxtBg:setEnable(false);
				end
					self:setKilled(self.data.is_live == 0);
				end
		else
			self.bossNameTxt.text = colorStr .. "Lv." .. tostring(self.data.lvl) .. " " .. self.cfg.name;
			self.bossNameTxt:setLocation(-130, -25, 0);

			if self.nameTxtBg ~= nil then
				self.nameTxtBg:setEnable(false);
			end
			self:setKilled(self.data.is_live == 0);
		end

		if self.cfg.boss_grade_text ~= nil then
			self:setGradeShow(true);
			self.titleTxt.text = self.cfg.boss_grade_text;
		else
			self:setGradeShow(false);
		end

		local iconUrl = "/images/head/boss/monster_" .. self.cfg.head_src .. ".png";
		if self.headIcon == nil then
			self.headIcon = UICreate.createImage(self.content, iconUrl, 0, 0, 0, 0);
			self.headIcon.name = "headIcon";
			self.headIcon.pivot = UIWidget.Pivot.Right;
			self.headIcon:setDepth(2);
			self.headIcon:setUVRect(Vector4(0.01, 0, 1, 1));
			self.headIcon:setLocation(self.bg.width / 2 - 2, 2, 0);
		end
		self.headIcon:addLoadCompleteFun(self, self.onLoadCompleteImg);
		self.headIcon:SetDimensions(0, 0);
		self.headIcon:setUrl(iconUrl);
		self.headIcon:setGray(self.sGray);

		if self.cfg.boss_mark ~= nil then
			self.followedMark2:setEnable(true);
			self.followedMark2:setBgAltas(self.cfg.boss_mark[1]);
			self.followedMark2:setLabelText(self.cfg.boss_mark[2]);
		else
			self.followedMark2:setEnable(false)
		end

		if DataCenter.bossData.curOpenUIType == Lua_BossData.TYPE_CHAOTIC_KUAFU then
			if self.data.gather_id ~= nil and tonumber(self.data.gather_id) > 0 then
				if DataCenter.bossData.OnUpdataZQ == true then
					if self.zhanqiIcon == nil then
						self.zhanqiIcon = UICreate.createUIAtlasImage(self.content, "", "", -110, 23, 36, 51);
						self.zhanqiIcon:setDepth(3);
					end
					self.zhanqiIcon:setAltas("bossWindow", tostring(self.data.gather_id));
					self.zhanqiIcon:setEnable(true);

					if tonumber(self.data.gather_id) == 502102350 then
						if self.zqEffect == nil then
							self.zqEffect = UICreate.createUIEffect(self.zhanqiIcon.mainContent, "/effects/scsEffects/gui_hundunqizi", "gui_hundunqizi", 0, 0);
							self.zqEffect:SetRenderQueue(self.zhanqiIcon, 10, 2, false);
						end
						self.zqEffect:setEnable(true);
					elseif self.zqEffect ~= nil then
						self.zqEffect:dispose();
						self.zqEffect = nil;
					end
				elseif self.zhanqiIcon ~= nil then
					self.zhanqiIcon:setEnable(false);
					if self.zqEffect ~= nil then
						self.zqEffect:dispose();
						self.zqEffect = nil;
					end
				end
			elseif self.zhanqiIcon ~= nil then
				self.zhanqiIcon:setEnable(false);
				if self.zqEffect ~= nil then
					self.zqEffect:dispose();
					self.zqEffect = nil;
				end
			end
		end
	end
end

function Lua_BossListBaseItem:onLoadCompleteImg()
	self.headIcon:SetDimensions(self.headIcon.width, 92);
end

function Lua_BossListBaseItem:setGradeShow(val)
	self.titleDi:setEnable(val);
	self.titleTxt:setEnable(val);
end

function Lua_BossListBaseItem:setKilled(val)
	self.iskilled = val;
	self:setGray(false);
	-- 2018 9.10 策划需求，将死亡的boss如果有关注，则继续关注
	-- 2018.2.2 策划需求：只有个人boss需要显示已击杀
	-- 2018.3.28 策划需求BUG #7680 【个人boss】玩法优化 3.原本的击杀标识和怪物头像标识变灰取消
	
	-- if self.data~= nil and DataCenter.bossData.curOpenUIType == Lua_BossData.TYPE_PERSONAL then
	-- 	self.mark:setEnable(val);
	-- 	self.killedTxt:setEnable(val);
	-- end
	-- self:setGray(val);

	-- 2018.2.2 策划需求：个人boss不显示死亡倒计时
	-- 2018.3.28 策划需求BUG #7680 【个人boss】玩法优化 1.改为可以多次击杀同一个怪物，无冷却时间，怪物重生时间
	-- 2018.4.11 野外、皇陵、限时的都是这样显示倒计时
	Lua_CommonUtil.removeTimer(self, self.reliveCountDown);
	if self.data ~= nil and DataCenter.bossData.curOpenUIType ~= Lua_BossData.TYPE_PERSONAL then
		-- if DataCenter.bossData.curOpenUIType == Lua_BossData.TYPE_ISLE_BOSS then
		-- 	self.countDownBg:setEnable(val);
		self.countDownTxt:setEnable(val);
		if self.iskilled == true and self.data.relive_sec > 0 then
			local detailVo = DataCenter.bossData:getBossDetailByType(DataCenter.bossData.curOpenUIType)
			self.endTime =detailVo.reliveEndTimes[tostring(self.data.monster_id)];
			Lua_CommonUtil.addTimer("PERSONAL_BOSS_RELIVE_COUNTDOWN", 1, self, self.reliveCountDown, nil, -1)
			if DataCenter.bossData.curOpenUIType == Lua_BossData.TYPE_ISLE_BOSS or DataCenter.bossData.curOpenUIType == Lua_BossData.TYPE_ISLEBOSS_KUAFU or DataCenter.bossData.curOpenUIType == Lua_BossData.TYPE_PRIMITIVE_KUAFU then
				local cconfig = Lua_MonsterConfigData.new(self.data.monster_id);
				if cconfig.isCollect == true or self.cfg.monster_type == nil or self.cfg.monster_type < 100 then
					self.countDownTxt.text = LanUtil.getValue(121661) .. TimeTransform.getInstance():transSeconds6(self.endTime - getTime(), true, true);
					self.countDownTxt:setLocation(-130, -25, 0);
					self:setGray(false);
				else
					self.countDownTxt.text = TimeTransform.getInstance():transSeconds6(self.endTime - getTime(), true, true);
					self.countDownTxt:setLocation(57, -25, 0);
					self:setGray(val);
				end
			else
				self.countDownTxt.text = TimeTransform.getInstance():transSeconds6(self.endTime - getTime(), true, true);
				self.countDownTxt:setLocation(57, -25, 0);
				self:setGray(val);
			end
		end
	else
		self.countDownTxt:setEnable(false);
	end

	if self.data ~= nil then
		self.followedMark:setEnable(self.data.is_follow == 1);
	else
		self.followedMark:setEnable(false);
	end
end

function Lua_BossListBaseItem:reliveCountDown()
	if self.data == nil then
		return;
	end

	local now = getTime();
	if self.endTime - now > 0 then
		-- self.countDownTxt.text = TimeTransform.getInstance():transSeconds6(self.endTime - now, true, true);
		if DataCenter.bossData.curOpenUIType == Lua_BossData.TYPE_ISLE_BOSS or DataCenter.bossData.curOpenUIType == Lua_BossData.TYPE_ISLEBOSS_KUAFU or DataCenter.bossData.curOpenUIType == Lua_BossData.TYPE_PRIMITIVE_KUAFU then
			local cconfig = Lua_MonsterConfigData.new(self.data.monster_id);
			if cconfig.isCollect == true or self.cfg.monster_type == nil or self.cfg.monster_type < 100 then
				self.countDownTxt.text = LanUtil.getValue(121661) .. TimeTransform.getInstance():transSeconds6(self.endTime - getTime(), true, true);
				self.countDownTxt:setLocation(-130, -25, 0);
			else
				self.countDownTxt.text = TimeTransform.getInstance():transSeconds6(self.endTime - getTime(), true, true);
				self.countDownTxt:setLocation(57, -25, 0);
			end
		else
			self.countDownTxt.text = TimeTransform.getInstance():transSeconds6(self.endTime - getTime(), true, true);
			self.countDownTxt:setLocation(57, -25, 0);
		end
	else
		if DataCenter.bossData.curOpenUIType == Lua_BossData.TYPE_ISLE_BOSS or DataCenter.bossData.curOpenUIType == Lua_BossData.TYPE_ISLEBOSS_KUAFU or DataCenter.bossData.curOpenUIType == Lua_BossData.TYPE_PRIMITIVE_KUAFU then
			if self.cfg.monster_type == nil or self.cfg.monster_type == 0 or self.cfg.monster_type >= 1 and self.cfg.monster_type <= 9 then
				local c = getConfig( { "god_monster", self.data.monster_id });
				if DataCenter.bossData.curOpenUIType == Lua_BossData.TYPE_ISLEBOSS_KUAFU then
					c = getConfig( { "tv_god_monster", self.data.monster_id });
				end

				Lua_CommonUtil.removeTimer(self, self.reliveCountDown);
				if DataCenter.bossData.curOpenUIType == Lua_BossData.TYPE_PRIMITIVE_KUAFU then
					Lua_CommonUtil.removeTimer(self, self.getWinData);
					Lua_CommonUtil.addTimer("TYPE_PRIMITIVE_KUAFU", 0.5, self, self.getWinData, nil, 1)
				else
					local detailVo = DataCenter.bossData:getBossDetailByType(DataCenter.bossData.curOpenUIType)
					--    print("sssss", self.data.monster_id, c)
					detailVo.reliveEndTimes[tostring(self.data.monster_id)] = getTime() + c.reset_boss_time;
					self:setKilled(true);
				end
			end
		else
			Lua_CommonUtil.removeTimer(self, self.reliveCountDown);
			self:setKilled(false);
		end
	end
end

function Lua_BossListBaseItem:getWinData()
	Lua_CommonUtil.removeTimer(self, self.getWinData);
	local cmd = getProtoMsg("Proto10401602");
	cmd.type = DataCenter.bossData.curOpenUIType;
	sendMsg(10401602, cmd);
end

function Lua_BossListBaseItem:setGray(val)
	if self.nameTxtBg ~= nil then
		self.nameTxtBg:setGray(val);
	end
	self.bg:setGray(val);
	self.bossNameTxt:setGray(val);

	if self.headIcon ~= nil then
		self.headIcon:setGray(val);
	end
	self.sGray = val;
end

function Lua_BossListBaseItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	self.selectIcon:setEnable(val);
	if val == true then
		-- self.bg:setAltas("common_atlas_1", "ui_common_widget_p2");
		Lua_MsgUtil.callFunc("BOSS_LIST_ITEM_CLICK", self.data);
	else
		-- self.bg:setAltas("common_atlas_1", "ui_common_widget_p1");
	end
end

function Lua_BossListBaseItem:checkOutBound(showRect)
	if self.zqEffect ~= nil then
		local rect = Lua_Rectangle.new(self.itemX, self.itemY, 50,50);
		self.zqEffect:setEnable(showRect:containeRect(rect));
	end
end

function Lua_BossListBaseItem:dispose()
	if self.zqEffect ~= nil then
		self.zqEffect:dispose();
		self.zqEffect = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.reliveCountDown);
	Lua_CommonUtil.removeTimer(self, self.getWinData);
	self.data = nil;

	self:superCall("dispose");
end