Lua_BossCopyBuyTimesWindow = class("Lua_BossCopyBuyTimesWindow", Lua_ThirdSizeWindow);
function Lua_BossCopyBuyTimesWindow:ctor()
	self:superCall("ctor", true, 3500, true, LanUtil.getValue(121619));

	self.windowName = "Lua_BossCopyBuyTimesWindow";
	self.skinName = "BossCopyBuyTimesWindow_skin";
	self.w = 600;
	self.h = 406;
end

function Lua_BossCopyBuyTimesWindow:buildShowItem()
	self:superCall("buildShowItem");
	
	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setLocation(0, 90, 0);

	self.needTotalMoney = 0;
	
	self.cancelBtn:addClickFuntion(self, self.hide);
	self.subBtn:addClickFuntion(self, self.onSureClick);
end

function Lua_BossCopyBuyTimesWindow:showWin(param)
	self.scene_id= param.scene_id;
	self.monster_id= param.monster_id;
	self.space_id = param.space_id;
	self.callBack = param.callBack;

	local costTicket = param.costTicket;
	local leftTicket = param.leftTicket;
	local sceneCfg = Lua_SceneConfigData.getSceneConfig(param.scene_id);
	local tickMoney = sceneCfg.config.tick_money;
	local needBuyCount = costTicket - leftTicket;
	self.needTotalMoney = tonumber(tickMoney * needBuyCount);

	local bossType = param.type;
	local copyTypeName = "";
	if bossType == Lua_BossData.TYPE_PERSONAL then
		copyTypeName = LanUtil.getValue(121602);
	elseif bossType == Lua_BossData.TYPE_TIMELIMIT then
		copyTypeName = LanUtil.getValue(121603);
	elseif bossType == Lua_BossData.TYPE_CHAOTIC_KUAFU then
		copyTypeName = LanUtil.getValue(128631);
	elseif bossType == Lua_BossData.TYPE_PRIMITIVE_KUAFU then
		copyTypeName = LanUtil.getValue(140100);
	end
	self.costConfirmTxt.text = LanUtil.formateStr(LanUtil.getValue(121618), copyTypeName,tostring(needBuyCount), param.itemName,tostring(self.needTotalMoney), param.itemName);

	local itemId = sceneCfg.config.tick_item;
	local tvo =  Lua_ToolVo.createToolVo(itemId, 1, 1);
	self.itemImg.data = tvo;

	self.itemImg:showNum2(leftTicket, costTicket, 2);
end

function Lua_BossCopyBuyTimesWindow:onSureClick(go)
	--检查元宝是否足够
	if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD_AND_BINDGOLD,self.needTotalMoney,true,true) == false then
		return;
	end

	if self.callBack ~= nil then
		self.callBack();
		self:hide();
		return;
	end
	DataCenter.bossData.needTrackBossId = self.monster_id;
	DataCenter.bossData.needTrackSceneId = tonumber(self.scene_id);
	
	local cmd = getProtoMsg("Proto10401601");
	cmd.scene_id = self.scene_id;
	cmd.space_id = self.space_id ;
	cmd.monster_id = self.monster_id;
	sendMsg(10401601, cmd);
	
	self:hide();
end