checkRequire("Lua_IsleBossCopyInfoItem");
Lua_BossCopyInfoList = class("Lua_BossCopyInfoList", Lua_DisplayObject);
function Lua_BossCopyInfoList:ctor(p)
	self:superCall("ctor", p);
end

function Lua_BossCopyInfoList:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 268, 192));

	self.countDownTxt = UICreate.createLabel(self.content, "", -116, -120, 246, 30, 20);
	self.countDownTxt.pivot = UIWidget.Pivot.Left;
	self.countDownTxt.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.countDownTxt:setDepth(2);

	self:addLuaEvent("BossCopyInfo_CLICK", self, self.onItemClick);
end

function Lua_BossCopyInfoList:setData(msg)
	-- msg:Proto80403903
	local tarr = Array();
	DataCenter.bossData.bossCopyReliveSecDic = {};
	if msg.type == Lua_BossData.TYPE_ISLE_BOSS or msg.type == Lua_BossData.TYPE_ISLEBOSS_KUAFU then
		local list1 = Array();
		local list2 = Array();
		local list3 = Array();
		for k, v in ipairs(msg.boss_detail_set) do
			local c = getConfig({"monster", v.monster_id});
			if c.monster_type == nil or c.monster_type == 0 then
				list2:add({msgData = v, lvl = v.lvl});
			elseif c.monster_type >= 1 and c.monster_type <= 9 then
				list1:add({msgData = v, lvl = v.lvl});
			elseif c.monster_type >= 101 then
				list3:add({msgData = v, lvl = v.lvl});
			end
			DataCenter.bossData.bossCopyReliveSecDic[tostring(v.monster_id)] = getTime() + v.relive_sec;
		end

		for i = 1, list1:getSize() do
			tarr:add(list1[i]);
		end

		for i = 1, list2:getSize() do
			tarr:add(list2[i]);
		end

		-- boss按等级排序
		list3:sort("lvl", false);
		for i = 1, list3:getSize() do
			tarr:add(list3[i]);
		end
	else
		for k, v in ipairs(msg.boss_detail_set) do
			tarr:add({msgData = v, lvl = v.lvl});
			DataCenter.bossData.bossCopyReliveSecDic[tostring(v.monster_id)] = getTime() + v.relive_sec;
		end
		tarr:sort("lvl", false);
	end

	DataCenter.bossData.curBossInfoListType = msg.type;
	if msg.type == Lua_BossData.TYPE_ISLE_BOSS or msg.type == Lua_BossData.TYPE_ISLEBOSS_KUAFU then
		self.dragList:setRect(Vector4(0, 0, 268, 236));
		self.dragList:setListCell(Lua_IsleBossCopyInfoItem, 48, 268, 1);
	elseif msg.type == Lua_BossData.TYPE_CHAOTIC_KUAFU then
		self.dragList:setRect(Vector4(0, 0, 268, 100));
		self.dragList:setListCell(Lua_BossCopyInfoItem, 27, 268, 1);

		self.countDownTxt:setLocation(-116, -77, 0);
	else
		self.dragList:setRect(Vector4(0, 0, 268, 192));
		self.dragList:setListCell(Lua_BossCopyInfoItem, 48, 268, 1);
	end

	self.dataList = tarr;
	if self.selectedData == nil and DataCenter.bossData.moveToMonsterId ~= 0 then
		for i = 1, tarr:getSize() do
			if tarr[i].msgData.monster_id == DataCenter.bossData.moveToMonsterId then
				self.selectedData = tarr[i];
				break;
			end
		end
	end
	self:onItemClick(self.selectedData);

	Lua_CommonUtil.removeTimer(self, self.endCountDown);
	if msg.left_time > 0 then
		self.endTime = getTime() + msg.left_time;
		Lua_CommonUtil.addTimer("Lua_BossCopyInfoList", 0.1, self, self.endCountDown);
	end
end

function Lua_BossCopyInfoList:setShowColor(colorStr)
	self.colorStr = colorStr;
end

function Lua_BossCopyInfoList:setSelectSize(selectWidth, selectHeight)
	self.selectWidth = selectWidth;
	self.selectHeight = selectHeight;
end

function Lua_BossCopyInfoList:onItemClick(val)
	self.selectedData = val;
	local len = self.dataList:getSize();
	for i = 1, len do
		if val ~= nil and val.msgData.monster_id == self.dataList[i].msgData.monster_id then
			self.dataList[i].selected = true;
		else
			self.dataList[i].selected = false;
		end
		self.dataList[i].colorStr = self.colorStr;
		self.dataList[i].width = self.selectWidth;
		self.dataList[i].height = self.selectHeight;
	end
	self.dragList:setLuaArrayData(self.dataList, false);
end

function Lua_BossCopyInfoList:endCountDown()
	if self.endTime == nil then
		return;
	end

	local sec = self.endTime - getTime();
	if sec > 0 then
		self.countDownTxt.text = LanUtil.getValue(121628) .. TimeTransform.getInstance():transSeconds6(sec, true, true);
	else
		Lua_CommonUtil.removeTimer(self, self.endCountDown);
	end
end

function Lua_BossCopyInfoList:dispose()
	Lua_CommonUtil.removeTimer(self, self.endCountDown)
	self:superCall("dispose");
end





--------------------------------------------------





-- BOSS之家左侧信息栏Item
Lua_BossCopyInfoItem = class("Lua_BossCopyInfoItem", Lua_ListCell);
function Lua_BossCopyInfoItem:ctor(p)
	self:superCall("ctor", p, "BossCopyInfoItem_skin");
end

function Lua_BossCopyInfoItem:buildShowItem()
	self:superCall("buildShowItem");

	self.selectIcon:setEnable(false);
end

function Lua_BossCopyInfoItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.cfg = getConfig({"monster", data.msgData.monster_id});
	if self.cfg == nil then
		return;
	end

	Lua_CommonUtil.removeTimer(self, self.reliveCountdown);
	if data.msgData.is_live == 1 then
		self.lvLab.text = "[85A8BE]Lv" .. data.msgData.lvl .. "[-]";
		self.bossNameLab.text = "[85A8BE][u][url=" .. data.msgData.monster_id .. "]" .. self.cfg.name .. "[/url][/u][-]";
		self.refreshLab.text = "[00E125]" .. LanUtil.getValue(121627) .. "[-]";
	else
		self.lvLab.text = "[FF1616]Lv" .. data.msgData.lvl .. "[-]";
		self.bossNameLab.text = "[FF1616][u][url=" .. data.msgData.monster_id .. "]" .. self.cfg.name .. "[/url][/u][-]";

		self.endTime = DataCenter.bossData.bossCopyReliveSecDic[tostring(data.msgData.monster_id)];
		self:addTimer("Lua_BossCopyInfoItem" .. tostring(data.msgData.monster_id), 0.1, self, self.reliveCountdown, nil, -1);
	end

	self.selectIcon:setEnable(data.selected);
end

function Lua_BossCopyInfoItem:reliveCountdown()
	if getTime() > self.endTime then
		self.refreshLab.text = "[00E125]" .. LanUtil.getValue(121627) .. "[-]";
		Lua_CommonUtil.removeTimer(self, self.reliveCountdown);
	else
		self.refreshLab.text = "[FF1616]" .. TimeTransform.getInstance():transSeconds6(self.endTime - getTime(), true, true) .. "[-]";
	end
end

function Lua_BossCopyInfoItem:onPlayerSoundClick()
	if self._data.msgData.is_live == 1 then
		self:moveToMonster();
	else
		local url = self.bossNameLab:getUrlByMousePos();
		if url ~= nil then
			self:moveToMonster();
		end
	end
	Lua_MsgUtil.callFunc("BossCopyInfo_CLICK", self._data);
end

function Lua_BossCopyInfoItem:moveToMonster()
	local rolePlayer = ThingUtil.instance:getThingById(DataCenter.roleData.roleId);
	if rolePlayer ~= nil and self._data ~= nil then
		if GlobalVar.hooking == true then
			DataCenter.hook:stop(true);
		end

		local monsterId = tonumber(self._data.msgData.monster_id);
		local nextAction = WorldMapUtil.genArriveActionVo({type = 8, monsterId = Lua_CommonUtil.trnsLongNum(monsterId), dailytask = 0});
		WorldMapUtil.moveTo(self._data.msgData.scene_id, self._data.msgData.pos.pixel_x, self._data.msgData.pos.pixel_y, self._data.msgData.pos.pixel_z, 0, 0, nextAction, 0);
	end
end

function Lua_BossCopyInfoItem:dispose()
	self._data = nil;
	Lua_CommonUtil.removeTimer(self, self.reliveCountdown);
	
	self:superCall("dispose");
end