-- BOSS之家左侧信息栏面板
checkRequire("Lua_LeftInfoBaseWindow");
checkRequire("Lua_BossCopyInfoList");
checkRequire("Lua_BossMonsterList");
Lua_BossCopyInfoWindow = class("Lua_BossCopyInfoWindow", Lua_LeftInfoBaseWindow);
function Lua_BossCopyInfoWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_BossCopyInfoWindow";
end

function Lua_BossCopyInfoWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.bg = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_bg_07", 141, 181.5, 256, 241);
	self.bg.name = "bg";
	self.bg.clickScale = false;
	self.bg.pivot = UIWidget.Pivot.Top;
	self.bg:setDepth(0);
	self.bg:addClickFuntion(self, self.onBgClick);
	
	self.bossList = Lua_BossCopyInfoList.new(self.content); -- BOSS
	self.bossList:setLocation(141, 83, 0);

	self.monsterList = Lua_BossMonsterList.new(self.content); -- 小怪
	self.monsterList:setLocation(141, 83, 0);
	
	local arr = Array();
	arr:add(LanUtil.getValue(110616));
	arr:add(LanUtil.getValue(121624));

	self.btnList = Lua_ButtonList.new(self.content, arr, 113, self, self.onButtonListClick,
		"ui_zhujiemian_title_02", "ui_zhujiemian_title_01", Vector4(0, 0, 112, 32), Vector4(0, 0, 112, 32),
		Lua_ColorDefine.transColor("F2F7FF"), Lua_ColorDefine.transColor("FFFFFF"), Vector4(22, 22, 112, 32), 2, 
		"mainWindow_atlas", Vector3(0, 0, 0), Vector3(0, 0, 0), "2D3640", "815800");
	self.btnList:setLocation(68.5, 196, 0);
	self.btnList:setDepth(5);
	self.btnList:setSelected(1, true);
	
	self:onSceneLoaded();
	
	self:addLuaEvent("SCENE_LOADED", self, self.onSceneLoaded);
	self:addLuaEvent("MENU_OUT_CLICK", self, self.onMenuOutClick);
	self:addLuaEvent("BOSS_COPY_SCENE_INFO_UPDATE",self,self.onBossCopySceneInfoUpdate);
end

function Lua_BossCopyInfoWindow.Get:hideOffset()
	return -275;
end

function Lua_BossCopyInfoWindow:setShowState(val)
	self:superCall("setShowState", val);

	if val then
		self.closeBtn:setLocation(253.5, 192, 0);
		self.closeIcon:setLocation(252, 196, 0);
	else
		self.closeBtn:setLocation(259.5 + self.closeBtn.width + 13, 192, 0);
		self.closeIcon:setLocation(258 - 1.5 + self.closeBtn.width + 13, 196, 0);
	end
end

function Lua_BossCopyInfoWindow:onSceneLoaded()
	local sceneConfig = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
	if sceneConfig.show_monster_list == 1 and self.state == 1 then
		if self.switchIcon == nil then
			self.switchIcon = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_qiehuan", 141, -37, 0, 0);
			self.switchIcon.name = "switchIcon";
			self.switchIcon:setDepth(2);
			self.switchIcon:addClickFuntion(self, self.onSwitchClick);
		end
		self.switchIcon:setEnable(true);
		self.bg:SetDimensions(256, 241);
	else
		if self.switchIcon ~= nil then
			self.switchIcon:setEnable(false);
		end
		self.bg:SetDimensions(256, 196);
	end
end

function Lua_BossCopyInfoWindow:onSwitchClick(go)
	if self.mstate == 1 then
		self.mstate = 2;
	else
		self.mstate = 1;
	end
	self:updateMonsterList();
end

function Lua_BossCopyInfoWindow:updateMonsterList()
	if self.mstate == 1 then
		self.bossList:setEnable(false);
		self.monsterList:setEnable(true);
		self.monsterList:updateMonsterList();
		self.btnList.pageArr[1].txt.text = LanUtil.getValue(110039);
	else
		self.bossList:setEnable(true);
		self.monsterList:setEnable(false);
		self.btnList.pageArr[1].txt.text = LanUtil.getValue(110040);
	end
	LuaUtil.updateWindowDepth(nil);
end

function Lua_BossCopyInfoWindow:onMonsterListChange(state)
	local sceneConfig = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
	if sceneConfig.show_monster_list == 1 then
		if state == 1 then
			self.btnList.pageArr[1].txt.text = LanUtil.getValue(110039);
		else
			self.btnList.pageArr[1].txt.text = LanUtil.getValue(110040);
		end
	else
		self.btnList.pageArr[1].txt.text = LanUtil.getValue(107491);
	end
end

function Lua_BossCopyInfoWindow:onMenuOutClick(o)
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(121635), type = 1, subFun = self.onOutClick});
end

function Lua_BossCopyInfoWindow:onOutClick(val)
	sendMsg(10400902);
end

function Lua_BossCopyInfoWindow:onBossCopySceneInfoUpdate(msg)
	self.bossList:setData(msg);
end

function Lua_BossCopyInfoWindow:showWin(msg)
	if self.bossList ~= nil then
		self.bossList:setData(msg);
	end

	--BUG #7685 【boss玩法】优化：前往boss位置方式
	if DataCenter.bossData.needTrackBossId ~= nil then
		local bossId = DataCenter.bossData.needTrackBossId;
		local sceneId = DataCenter.bossData.needTrackSceneId;
		local bossDetail = nil;
		for k,v in ipairs(msg.boss_detail_set) do
			if v.monster_id == bossId then
				bossDetail = v;
				break;
			end
		end
		if bossDetail ~= nil then
			--print("bossDetail sceneId "..tostring(sceneId).." monsterId "..tostring(bossId));
			local tbossId = tonumber(bossId);	
			local nextAction = WorldMapUtil.genArriveActionVo({type= 8,monsterId =  Lua_CommonUtil.trnsLongNum(tbossId),dailytask = 0});
			WorldMapUtil.moveTo(sceneId, bossDetail.pos.pixel_x, bossDetail.pos.pixel_y, bossDetail.pos.pixel_z,0, 0,nextAction, 0);
			DataCenter.bossData.needTrackBossId = nil;
			DataCenter.bossData.needTrackSceneId = nil;
		end
	end
end
	
function Lua_BossCopyInfoWindow:onButtonListClick(val)
	self.state = val;
	if val == 1 then
		self.bg:setEnable(true);
		self:updateMonsterList();
		if self._teamPanel ~= nil then
			self._teamPanel:setEnable(false);
		end
	else
		self.bg:setEnable(false);
		self.bossList:setEnable(false);
		self.monsterList:setEnable(false);
		self.teamPanel:setEnable(true);
	end
	self:onSceneLoaded();
end

function Lua_BossCopyInfoWindow.Get:teamPanel()
	if self._teamPanel == nil then
		self._teamPanel = Lua_TeamPanel.new(self.content);
		self._teamPanel:setLocation(0, 54, 0);
	end
	return self._teamPanel;
end

function Lua_BossCopyInfoWindow:dispose()
	if self.bg ~= nil then
		self.bg:dispose();
		self.bg = nil;
	end
	if self.bossList ~= nil then
		self.bossList:dispose();
		self.bossList = nil;
	end
	if self.monsterList ~= nil then
		self.monsterList:dispose();
		self.monsterList = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self.switchIcon ~= nil then
		self.switchIcon:dispose();
		self.switchIcon = nil;
	end
	if self._teamPanel ~= nil then
		self._teamPanel:dispose();
		self._teamPanel = nil;
	end

	self:superCall("dispose");
end