-- 掉落记录
Lua_BossDropRecordPanel = class("Lua_BossDropRecordPanel", Lua_DisplayObject);
function Lua_BossDropRecordPanel:ctor(p)
	self:superCall("ctor", p);
end

function Lua_BossDropRecordPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.desBg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_widget_001", 124, -29, 947, 600);
	self.desBg.name = "desBg";

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 914, 580));
	self.dragList:setLocation(124, -29, 0);
	self.dragList:setListCell(Lua_BossDropRecordListItem, 61, 914, 1);

	if WindowMananger.getInstance():isWindowShowing("Lua_BossMainWindow") == false then
		self.panelType = Lua_BossData.TYPE_DROPITEMS_KUAFU
		local cmd = getProtoMsg("Proto10101650");
		cmd.type = self.panelType;
		sendMsg(10101650, cmd);
	else
		self.panelType = Lua_BossData.TYPE_DROP_ITEMS
		local cmd = getProtoMsg("Proto10401602");
		cmd.type = self.panelType;
		sendMsg(10401602, cmd);
	end

	self:addLuaEvent("BOSS_DATA_INFO_UPDATE", self, self.updateDetailInfo);
end

function Lua_BossDropRecordPanel:updateDetailInfo(type)
	if type ~= self.panelType then
		return;
	end

	local dropData = DataCenter.bossData:getBossDetailByType(type);
	if dropData ~= nil and dropData.itemRecord ~= nil then
		local arr = Array();
		for k, v in ipairs(dropData.itemRecord) do
			arr:add(v);
		end
		self.dragList:setLuaArrayData(arr, false);
	end
end

function Lua_BossDropRecordPanel:dispose()
	if self.desBg ~= nil then
		self.desBg:dispose();
		self.desBg = nil;
	end
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end

	self:superCall("dispose");
end





--------------------------------------------------





Lua_BossDropRecordListItem = class("Lua_BossDropRecordListItem", Lua_ListCell)
function Lua_BossDropRecordListItem:ctor(p)
	self:superCall("ctor", p, "BossDropRecordListItem_skin");
end

function Lua_BossDropRecordListItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_BossDropRecordListItem:setData(data)
	-- data :ProtoServerRecord
	-- data.player_name:玩家名字
	-- data.sub_value:地图id
	-- data.sub_name:怪物名字
	-- data.item_id:物品id
	self.timeTxt.text = TimeTransform.getInstance():transSeconds8(data.get_tme, "MM-dd HH:mm:ss");

	local isSameServer = 1;
	if data.server_name ~= "" and DataCenter.roleData.server_name ~= "" and data.server_name ~= DataCenter.roleData.server_name then
		isSameServer = 0;
	end

	self.toolItem = Lua_ToolVo.createToolVo(data.item_id, 1, 1);
	self.toolItem:fromServer(data.item);
	local sceneName = getConfig({"scene", data.sub_value}).name;
	self.descTxt.text = LanUtil.formateStr(LanUtil.getValue(121633), tostring(data.player_id), data.player_name, 
		tostring(isSameServer), tostring(data.team_index), data.player_name, sceneName, data.sub_name, self.toolItem.colorName);
end

function Lua_BossDropRecordListItem:onPlayerSoundClick()
    self:checkUrlClick();
end

function Lua_BossDropRecordListItem:checkUrlClick()
    local urlStr = self.descTxt:getUrlByMousePos()
    if urlStr ~= nil then
        Lua_ChatUtil.urlClickHandle(urlStr, self.toolItem);
    end
end

function Lua_BossDropRecordListItem:dispose()
	self:superCall("dispose");
end