Lua_BossKilledRecordWindow = class("Lua_BossKilledRecordWindow", Lua_ThirdSizeWindow);
function Lua_BossKilledRecordWindow:ctor()
	self:superCall("ctor", true, 3500, true, LanUtil.getValue(121609));

	self.windowName = "Lua_BossKilledRecordWindow";
	self.isClickClose = false;
	self.w = 600;
	self.h = 406;
end

function Lua_BossKilledRecordWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.dragContainer = Lua_DragContainer.new(self.content, 1, Vector4(0, 0, 450, 330));
	self.dragContainer:setLocation(0, -30, 0);
	self.dragContainer.uiPanel.depth = 3000;
	self.logItem = Lua_BossKilledItem.new(self.dragContainer);
	self.dragContainer:updateChildPos();
	LuaUtil.updateWindowDepth(nil);
	self.dragContainer:updateChildPos();

	self:addLuaEvent("BOSS_KILLED_RECORD_UPDATE", self, self.updateRecord);
end

function Lua_BossKilledRecordWindow:updateRecord(msg)
	local logStr = "";
	for i, v in ipairs(msg.record) do
		-- print("v.left_time " .. tostring(v.left_time));
		logStr = logStr .. LanUtil.formateStr(LanUtil.getValue(121612), TimeTransform.getInstance():transSeconds8(v.left_time, "yyyy-MM-dd HH:mm:ss"), v.att_name) .. "\n";
	end
	self.logItem:setText(logStr);
	self.dragContainer:updateChildPos();
end

function Lua_BossKilledRecordWindow:showWin(val)
	local cmd = getProtoMsg("Proto10401603");
	if val.type == Lua_BossData.TYPE_ISLEBOSS_KUAFU or val.type == Lua_BossData.TYPE_PRIMITIVE_KUAFU then
		cmd = getProtoMsg("Proto10101651")
	end
	cmd.type = val.type;
	cmd.sort_id = val.monster_id
	if val.type == Lua_BossData.TYPE_ISLEBOSS_KUAFU or val.type == Lua_BossData.TYPE_PRIMITIVE_KUAFU then
		sendMsg(10101651, cmd);
	else
		sendMsg(10401603, cmd);
	end
end

function Lua_BossKilledRecordWindow:hide()
	self:superCall("hide");
	-- Lua_MsgUtil.callFunc("SHILED_BOSS_UI_AVATAR",false);
end





--------------------------------------------------





Lua_BossKilledItem = class("Lua_BossKilledItem", Lua_DragContainerItem);
function Lua_BossKilledItem:ctor(dragContainer)
	self:superCall("ctor", dragContainer.sub);

	dragContainer:addSubContainer(self, true);
end

function Lua_BossKilledItem:buildShowItem()
	self:superCall("buildShowItem");

	self.logTxt = UICreate.createLabel(self.content, "", -225, 165, 450, 30, 22);
	self.logTxt.spacingY = 9;
	self.logTxt.pivot = UIWidget.Pivot.TopLeft;
	self.logTxt.overflowMethod = UILabel.Overflow.ResizeHeight;
	self.logTxt:setDepth(5);
end

function Lua_BossKilledItem:setText(val)
	self.logTxt.text = val;
end

function Lua_BossKilledItem:getHeight()
	return self.logTxt.height;
end

function Lua_BossKilledItem:dispose()
	self:superCall("dispose");
end