checkRequire("Lua_MonsterListItem");
Lua_BossMonsterList = class("Lua_BossMonsterList", Lua_DisplayObject);
function Lua_BossMonsterList:ctor(p)
	self:superCall("ctor", p);
end

function Lua_BossMonsterList:buildShowItem()
	self:superCall("buildShowItem");
	
	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 268, 192));
	self.dragList:setListCell(Lua_MonsterListItem, 48, 268, 1);

	self:addLuaEvent("MonsterCopyInfo_CLICK", self, self.onItemClick);
end

function Lua_BossMonsterList:setDraglistInfo(vc, height)
	if self.dragList ~= nil then
		self.dragList:setRect(vc);
		self.dragList:setListCell(Lua_MonsterListItem, 27, 268, 1);
	end
end

function Lua_BossMonsterList:setShowState(state)
	self.lineShowState = state;
end

function Lua_BossMonsterList:setShowColor(colorStr)
	self.colorStr = colorStr;
end

function Lua_BossMonsterList:setSelectSize(selectWidth, selectHeight)
	self.selectWidth = selectWidth;
	self.selectHeight = selectHeight;
end

function Lua_BossMonsterList:onItemClick(val)
	self.selectedData = val;
	for i = 1, self.dataList:getSize() do
		if val ~= nil and val.id == self.dataList[i].id then
			self.dataList[i].selected = true;
		else
			self.dataList[i].selected = false;
		end
		self.dataList[i].showState = self.lineShowState;
		self.dataList[i].colorStr = self.colorStr;
		self.dataList[i].width = self.selectWidth;
		self.dataList[i].height = self.selectHeight;
	end
	self.dragList:setLuaArrayData(self.dataList);
end

function Lua_BossMonsterList:updateMonsterList()
	local arr = Array();
	local sceneConfig = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
	local monsterList = sceneConfig.config.monster;
	if monsterList ~= nil then
		for i,v in ipairs(monsterList) do
			local co = Lua_MonsterConfigData.new(v.id);
			if co.boss == 0 then
				arr:add(v);
			end
		end
	end
	self.dataList = arr;
	self:onItemClick(self.selectedData);
end

function Lua_BossMonsterList:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end