Lua_BossReliveTipsWindow = class("Lua_BossReliveTipsWindow", Lua_ThirdSizeWindow);
function Lua_BossReliveTipsWindow:ctor()
	self:superCall("ctor", false, 1000, true, "", false);

	self.windowName = "Lua_BossReliveTipsWindow";
	self.skinName = "BossReliveTipsWindow_skin";
	self.w = 300;
	self.h = 310;
end

function Lua_BossReliveTipsWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.gotoBtn:addClickFuntion(self, self.onGotoClick)
end

function Lua_BossReliveTipsWindow:showWin(param)
	self:superCall("showWin", param);

	local cfg = getConfig({"monster", param.sort_id});
	if cfg ~= nil then
		self.nameTxt.text = "Lv"..tostring(param.lvl).. cfg.name;
		if self.headIcon == nil then
			self.headIcon = UICreate.createImage(self.content, "", 0, 73, 0, 0);
			self.headIcon:setDepth(10);
		end
		self.headIcon:setUrl("/images/head/boss/"..tostring(cfg.head_src)..".png");
	end

	self.refreshTxt.text = LanUtil.getValue(121620);
	
	local half_w = MainWinDefine.V_width / 2;
	local half_h = MainWinDefine.V_height / 2;
	LuaUtil.setObjPos(self.content, half_w - 300, 0, 0);

	Lua_CommonUtil.removeTimer(self, self.hide);
	Lua_CommonUtil.delayCall(20, self, self.hide);
end

function Lua_BossReliveTipsWindow:onGotoClick(go)
	local checkTimes = true;
	if self.showData.type == Lua_BossData.TYPE_ISLEBOSS_KUAFU then
		local hlCfg = getConfig({"tv_god_scene"});
		local open_level = 0;
		local layerNum = 0;
		for k,v in ipairs(hlCfg) do
			if tonumber(v.scene_id) == self.showData.scene_id
				and v.open_level ~= nil
				and DataCenter.roleData.level < tonumber(v.open_level) then
				open_level = tonumber(v.open_level);
				layerNum = tonumber(k);
				break;
			end
		end

		if open_level > 0 and layerNum > 0 then
			OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(121673), tostring(layerNum), tostring(open_level)));
			if Lua_WindowUtil.isWindowShowing("Lua_BossReliveTipsWindow") == true then
				Lua_WindowUtil.openWin("Lua_BossReliveTipsWindow", WinParam.ACTION_CLOSE);
			end
			return;
		end
	end
	
	if self.showData.type == Lua_BossData.TYPE_HUANGLING
		or self.showData.type == Lua_BossData.TYPE_TIMELIMIT
		or self.showData.type == Lua_BossData.TYPE_WILD then
		checkTimes = false;
	end

	DataCenter.bossData:sEnterBossScene(
		self.showData.chall_count,
		self.showData.total_count,
		1,
		self.showData.sort_id,
		self.showData.space_id,
		self.showData.scene_id,
		checkTimes
	);
end