checkRequire("Lua_BossBasePanel"); -- 混沌战场
Lua_ChaoticBossPanel = class("Lua_ChaoticBossPanel", Lua_BossBasePanel)
function Lua_ChaoticBossPanel:ctor(p)
    self:superCall("ctor", p, "ChaoticBossPanel_skin", Lua_BossData.TYPE_CHAOTIC_KUAFU);
end

function Lua_ChaoticBossPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.attrTextcontainer:SetActive(false);
	self.followChk:setLocation(95, -40, -500);

	self.curSelectIdx = 1;
	self.listIdx = 1;
	self.firstSetIdx = true;
	self.layerDataDic = {};

	self.attrKey = Array();
	self.attrKey:add("metal_defence");
	self.attrKey:add("wood_defence");
	self.attrKey:add("water_defence");
	self.attrKey:add("fire_defence");
	self.attrKey:add("earth_defence");
	self.attrKey:add("hp");
	self.attrKey:add("attack");
	self.attrKey:add("defense");
	self.attrKey:add("hit");
	self.attrKey:add("avoid");

	self.powerKey = Array();
	self.powerKey:add("metal_power");
	self.powerKey:add("wood_power");
	self.powerKey:add("water_power");
	self.powerKey:add("fire_power");
	self.powerKey:add("earth_power");

	self.attackValue = Array();
	self.attackValue:add(DataCenter.roleData.baseParam.metal_power);
	self.attackValue:add(DataCenter.roleData.baseParam.wood_power);
	self.attackValue:add(DataCenter.roleData.baseParam.water_power);
	self.attackValue:add(DataCenter.roleData.baseParam.fire_power);
	self.attackValue:add(DataCenter.roleData.baseParam.earth_power);

	local layerNum = getConfig({"boss_base_info", "hundun_layer_val"});
	local arr = Array();
	for i = 1, layerNum.val do
		arr:add(LanUtil.formateStr(LanUtil.getValue(128632), LanUtil.getValue(100 + i)));
	end

	self.btnList = Lua_ButtonList.new(self.content, arr, 125.5, self, self.onBtnClick,
		"ui_common_btn_c2", "ui_common_btn_c1", Vector4(0, 0, 118, 53), Vector4(0, 0, 118, 53),
		Lua_ColorDefine.transColor("D2D8DC"), Lua_ColorDefine.transColor("FFFFFF"), Vector4(24, 24, 118, 30), 2, "common_atlas_1");
	self.btnList:setDepth(10);
	self.btnList:setLocation(-276, 234, 0);
	self.btnList:setSelected(1, false);

	self.attrList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 450, 120));
	self.attrList:setListCell(Lua_ChaoticBossAttrItem, 40, 220, 2);
	self.attrList:setLocation(-7, -147, 0);
	self.attrList:setEnable(false);

	self.remindTipsLab:setLocation(150, 232, -500);
	self.remindTipsLab.clickScale = false;
	self.remindTipsLab:addClickFuntion(self, self.onTipsClick);
	self.playerAttrBtn:addClickFuntion(self, self.onPlayerAttrClick);
	self.gotoBtn:addClickFuntion(self, self.onGotoClick);
end

function Lua_ChaoticBossPanel:updateDetailInfo(type)
	if type ~= self.type then
		return;
	end

	self.listData = DataCenter.bossData:getBossDetailByType(type);
	self.leftTimesTxt.text = LanUtil.formateStr(LanUtil.getValue(128605), self.listData.leftChall.."/"..self.listData.totalChall);

	self:setTipsLabel();
	self:clearLayerDataList();

	self.totalTime = 0;
	self.timeList = self.listData.gather_time_info[1];
	if self.timeList.obj_id ~= nil and tonumber(self.timeList.obj_id) <= 0 then
		self.totalTime = tonumber(self.timeList.obj_value);
		DataCenter.bossData.OnUpdataZQ = true;
	elseif self.timeList.obj_value ~= nil and tonumber(self.timeList.obj_value) <= 0 then
		self.totalTime = tonumber(self.timeList.obj_id);
		DataCenter.bossData.OnUpdataZQ = false;
	end
	self.curTime = getTime();
	self:startTimer();
	self:updataZHtime();

	self.layerDataDic = {};
	for k,v in ipairs(self.listData.bossDetailSet) do
		if self.layerDataDic[tostring(v.layer)] == nil then
			self.layerDataDic[tostring(v.layer)] = Array();
		end
		self.layerDataDic[tostring(v.layer)]:add(v);
	end

	for k,v in pairs(self.layerDataDic) do
		v:sort("monster_id", false);
	end

	self.dataList:clear();
	if DataCenter.bossData.checkBossId ~= nil then
		self:getMonsterIdLayer(DataCenter.bossData.checkBossId);
		self.needSetIdx = true;
		DataCenter.bossData.checkBossId = nil;
	end

	local tlist = self.layerDataDic[tostring(self.curSelectIdx)]
	if tlist ~= nil then
		self.dragList:setLuaArrayData(tlist, false);
		local idx = 1;
		if tlist:getSize() > 0 then
			idx = self.listIdx;
		end

		if self.needSetIdx then
			idx = self.monsterIndex;
			self.needSetIdx = false;
		end

		if self.firstSetIdx then
			self.dragList:moveToIndex(idx, true);
			self.dragList:setSelected(idx);
			self.firstSetIdx = false;
		end
	end

	if self.listData.start_time ~= nil and self.listData.start_time ~= 0 and self.listData.end_time ~= nil and self.listData.end_time ~= 0 then
		self.ruleTxt:setEnable(false);
		if self.allotBtn == nil then
			self.allotBtn = UICreate.createButton(self.content, LanUtil.getValue(128637), -230, -286, 141, 22);
			self.allotBtn.txt.colorStr = Lua_ColorDefine.transColor("FFFCB7")
			self.allotBtn:setDepth(5);
			self.allotBtn:setStyle(30);
			self.allotBtn:addClickFuntion(self, self.onEnterBtnClick);
		end
		self.allotBtn:setEnable(true);
	else
		self.ruleTxt:setEnable(true);
		self.ruleTxt.text = LanUtil.getValue(121664)
		if self.allotBtn ~= nil then
			self.allotBtn:setEnable(false);
		end
	end
end

function Lua_ChaoticBossPanel:setTipsLabel()
	if self.curSelectIdx == 4 then
		self.costTxt.text = LanUtil.formateStr(LanUtil.getValue(128607), self.listData.left_fatigued.."/"..self.listData.total_fatigued);
		self.leftTimeLab.text = LanUtil.getValue(128610);
		self.rewardUpTipsLab.text = LanUtil.getValue(128612);
	else
		self.costTxt.text = LanUtil.getValue(128606);
		self.rewardUpTipsLab.text = LanUtil.getValue(128611);
	end
	self.killRecordBg:setEnable(self.curSelectIdx == 4);
	self.killRecordBtn:setEnable(self.curSelectIdx == 4);
	self.followChk:setEnable(self.curSelectIdx == 4);
end

function Lua_ChaoticBossPanel:clearLayerDataList()
	if self.layerDataDic ~= nil then
		while #self.layerDataDic > 0 do
			self.layerDataDic[1]:clear();
			table.remove(self.layerDataDic, 1);
		end
	end
end

function Lua_ChaoticBossPanel:startTimer()
	if self.countDown ~= true then
		self.countDown = true;
		Lua_CommonUtil.addTimer("Lua_ChaoticBossPanel", 0.01, self, self.updataZHtime);
	end
end

function Lua_ChaoticBossPanel:updataZHtime()
	self.totalTime = self.totalTime - (getTime() - self.curTime);
	self.curTime = getTime();
	if self.curSelectIdx ~= 4 then
		if DataCenter.bossData.OnUpdataZQ then
			self.leftTimeLab.text = LanUtil.formateStr(LanUtil.getValue(128608), TimeTransform.getInstance():transSeconds6(math.ceil(self.totalTime), false, true));
		else
			self.leftTimeLab.text = LanUtil.formateStr(LanUtil.getValue(128609), TimeTransform.getInstance():transSeconds6(math.ceil(self.totalTime), false, true));
		end
	end

	if self.totalTime <= 0 then
		Lua_CommonUtil.removeTimer(self, self.updataZHtime);
		local cmd = getProtoMsg("Proto10401602");
		cmd.type = Lua_BossData.TYPE_CHAOTIC_KUAFU;
		sendMsg(10401602, cmd);
	end
end

function Lua_ChaoticBossPanel:endTimer()
	if self.countDown == true then
		self.countDown = false;
		Lua_CommonUtil.removeTimer(self, self.updataZHtime);
	end
end

function Lua_ChaoticBossPanel:onBtnClick(val)
	if self.curSelectIdx ~= val then
		self.listIdx = 1;
	end
	self.curSelectIdx = val;
	self:setTipsLabel();

	local arr = self.layerDataDic[tostring(self.curSelectIdx)]
	if arr ~= nil then
		self.dragList:setLuaArrayData(arr, false);
		if arr:getSize() > 0 then
			self.dragList:moveToIndex(self.listIdx, true);
			self.dragList:setSelected(self.listIdx);
		end
	end
end

function Lua_ChaoticBossPanel:onListItemClick(itemData)
	self:superCall("onListItemClick", itemData);

	self.firstSetIdx = true;
	self.listIdx = self.dragList.curSelectedIdx;

	-- print("Lua_ChaoticBossPanel", itemData.monster_id);
	local curCfg = getConfig({"monster", itemData.monster_id});
	local list = Array();
	for i = 1, self.attrKey:getSize() do
		if curCfg[self.attrKey[i]] ~= nil then
			list:add({key = self.attrKey[i], val = curCfg[self.attrKey[i]]});
		end
	end
	self.attrList:setLuaArrayData(list, false);

	local tempNum = 0;
	self.metal_defence = 0;
	self.wood_defence = 0;
	self.water_defence = 0;
	self.fire_defence = 0;
	self.earth_defence = 0;
	self.tipsStr = ""; -- LanUtil.getValue(128617);
	local isNeed = false;
	if curCfg.metal_defence ~= nil and tonumber(curCfg.metal_defence) > 0 then
		tempNum = tempNum + 1;
		
		self.metal_defence = tonumber(curCfg.metal_defence);
		self.tipsStr = self.tipsStr..LanUtil.formateStr(LanUtil.getValue(128618), tostring(curCfg.metal_defence));
		
		local differ = self.metal_defence - self.attackValue[1];
		if differ > 0 then
			self.tipsStr = self.tipsStr.."[FF1616](-"..differ..")[-]"
		end
		isNeed = true;
	end

	if curCfg.wood_defence ~= nil and tonumber(curCfg.wood_defence) > 0 then
		tempNum = tempNum + 1;

		if isNeed then
			isNeed = false;
			self.tipsStr = self.tipsStr.."\n";
		end
		self.wood_defence = tonumber(curCfg.wood_defence);
		self.tipsStr = self.tipsStr..LanUtil.formateStr(LanUtil.getValue(128619), tostring(curCfg.wood_defence));
		
		local differ = self.wood_defence - self.attackValue[2];
		if differ > 0 then
			self.tipsStr = self.tipsStr.."[FF1616](-"..differ..")[-]"
		end
		isNeed = true;
	end

	if curCfg.water_defence ~= nil and tonumber(curCfg.water_defence) > 0 then
		tempNum = tempNum + 1;

		if isNeed then
			isNeed = false;
			self.tipsStr = self.tipsStr.."\n";
		end
		self.water_defence = tonumber(curCfg.water_defence);
		self.tipsStr = self.tipsStr..LanUtil.formateStr(LanUtil.getValue(128620), tostring(curCfg.water_defence));
		
		local differ = self.water_defence - self.attackValue[3];
		if differ > 0 then
			self.tipsStr = self.tipsStr.."[FF1616](-"..differ..")[-]"
		end
		isNeed = true;
	end

	if curCfg.fire_defence ~= nil and tonumber(curCfg.fire_defence) > 0 then
		tempNum = tempNum + 1;

		if isNeed then
			isNeed = false;
			self.tipsStr = self.tipsStr.."\n";
		end
		self.fire_defence = tonumber(curCfg.fire_defence);
		self.tipsStr = self.tipsStr..LanUtil.formateStr(LanUtil.getValue(128621), tostring(curCfg.fire_defence));
		
		local differ = self.fire_defence - self.attackValue[4];
		if differ > 0 then
			self.tipsStr = self.tipsStr.."[FF1616](-"..differ..")[-]"
		end
		isNeed = true;
	end

	if curCfg.earth_defence ~= nil and tonumber(curCfg.earth_defence) > 0 then
		tempNum = tempNum + 1;

		if isNeed then
			isNeed = false;
			self.tipsStr = self.tipsStr.."\n";
		end
		self.earth_defence = tonumber(curCfg.earth_defence);
		self.tipsStr = self.tipsStr..LanUtil.formateStr(LanUtil.getValue(128622), tostring(curCfg.earth_defence));
		
		local differ = self.earth_defence - self.attackValue[5];
		if differ > 0 then
			self.tipsStr = self.tipsStr.."[FF1616](-"..differ..")[-]";
		end
	end

	if tempNum == 0 then
		self.tipsStr = "";
		self.remindTipsLab.text = "";
	else
		self.remindTipsLab.text = LanUtil.formateStr("[u][F7B930]{1}[-][/u]", LanUtil.getValue(128638));
	end
end

function Lua_ChaoticBossPanel:onAttributeClick(go)
	self.showingAttr = not self.showingAttr;
	self.bossAtrrBtn:setAltas("boss_atlas", self.showingAttr == true and "ui_boss_icon_4" or "ui_boss_icon_2");

	self.attrList:setEnable(self.showingAttr);
	self.rItem:setEnable(not self.showingAttr);

	if self.dropTitleTxt ~= nil then
		self.dropTitleTxt.text = self.showingAttr == true and LanUtil.getValue(121650) or LanUtil.getValue(121649);
	end
end

function Lua_ChaoticBossPanel:onTipsClick(go)
	Lua_WindowUtil.openWin("Lua_ShowAdviceTipsWindow", nil, self.tipsStr);
end

function Lua_ChaoticBossPanel:onPlayerAttrClick(go)
	local attrLb;
	self.str = "";
	for i = 1, self.powerKey:getSize() do
		attrLb = tostring(Lua_ThingDefine.getParamName(self.powerKey[i]));
		self.str = self.str..attrLb .."："..self.attackValue[i];
		if i < self.powerKey:getSize() then
			self.str = self.str.."\n";
		end
	end
	Lua_WindowUtil.openWin("Lua_SeampAllAttributeWindow", WinParam.ACTION_OPEN, self.str);
end

function Lua_ChaoticBossPanel:onGotoClick()
	if self.itemData == nil then
		return;
	end
	self:checkTimes();
end

function Lua_ChaoticBossPanel:checkTimes()
	if self.listData.leftChall <= 0 then
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(128623), type = 1, subFun = self.operVipWindw});
		return;
	end

	if DataCenter.roleData.baseParam.metal_power < self.metal_defence
		or DataCenter.roleData.baseParam.wood_power < self.wood_defence
		or DataCenter.roleData.baseParam.water_power < self.water_defence
		or DataCenter.roleData.baseParam.fire_power < self.fire_defence
		or DataCenter.roleData.baseParam.earth_power < self.earth_defence then
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(128624), type = 1, subFun = self.doSendEnterBossScene});
		return;
	end
	self:doSendEnterBossScene();
end

function Lua_ChaoticBossPanel:operVipWindw()
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow",WinParam.ACTION_OPEN, 10097);
	Lua_WindowUtil.openWin("Lua_MultipleServersWindow",WinParam.ACTION_CLOSE);
end

function Lua_ChaoticBossPanel:doSendEnterBossScene()
	self:superCall("doSendEnterBossScene");

	if GlobalVar.hooking == true then
		DataCenter.hook:stop(true);
	end

	local challCount = self.listData.totalChall - self.listData.leftChall;
	local sceneCfg = Lua_SceneConfigData.getSceneConfig(tonumber(self.itemData.scene_id));
	for i = 1, #sceneCfg.config.tick_cost do
		if self.listData.costTicket == sceneCfg.config.tick_cost[i] and i > 1 then
			challCount = i;
			break;
		end
	end

	if sceneCfg == nil or sceneCfg.config == nil then
		return;
	end

	if sceneCfg.config.tick_item ~= nil then
		local itemId = sceneCfg.config.tick_item;
		local costTicket = sceneCfg.config.tick_cost[challCount + 1];
		local leftTicket = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(itemId);
		local itemName = Lua_ToolVo.createToolVo(itemId, 1, 1).colorName;
		if costTicket ~= nil and leftTicket >= costTicket then
			Lua_WindowUtil.openWin("Lua_CopyEnterTipsWindow", WinParam.ACTION_OPEN, {type = sceneCfg.config.boss_copy_type,
				itemName = itemName, leftTicket = leftTicket, costTicket = costTicket, scene_id = self.itemData.scene_id,
				space_id = self.itemData.space_id, monster_id = self.itemData.monster_id});
			return;
		end
	end
	DataCenter.bossData:sEnterBossScene(challCount, self.listData.totalChall, self.itemData.is_live, self.itemData.monster_id, self.itemData.space_id, self.itemData.scene_id, false);
end

function Lua_ChaoticBossPanel:onRuleClick()
	self:superCall("onRuleClick");

	Lua_WindowUtil.openWin("Lua_RuleTipWindow", nil, LanUtil.getValue(128604));
end

function Lua_ChaoticBossPanel:onEnterBtnClick()
	local startTime = TimeTransform.getInstance():transSeconds8(self.listData.start_time, "MM-dd HH:mm");
	local endTime = TimeTransform.getInstance():transSeconds8(self.listData.end_time, "MM-dd HH:mm");
	Lua_WindowUtil.openWin("Lua_TipsWindow", WinParam.ACTION_OPEN, {owner = self, des = LanUtil.formateStr(LanUtil.getValue(128636), tostring(startTime), tostring(endTime)), 
		type = 2, subFun = self.onSubCallback});
end

function Lua_ChaoticBossPanel:onSubCallback()
end

function Lua_ChaoticBossPanel:dispose()
	Lua_CommonUtil.removeTimer(self, self.updataZHtime);
	self:superCall("dispose");
end





--------------------------------------------------





Lua_ChaoticBossAttrItem = class("Lua_ChaoticBossAttrItem", Lua_ListCell);
function Lua_ChaoticBossAttrItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_ChaoticBossAttrItem:buildShowItem()
	self:superCall("buildShowItem");

	-- self.attrKeyArr = Array();
	-- self.attrKeyArr:add("metal_defence");
	-- self.attrKeyArr:add("wood_defence");
	-- self.attrKeyArr:add("water_defence");
	-- self.attrKeyArr:add("fire_defence");
	-- self.attrKeyArr:add("earth_defence");

	-- self.attackList = Array();
	-- self.attackList:add(DataCenter.roleData.baseParam.metal_power);
	-- self.attackList:add(DataCenter.roleData.baseParam.wood_power);
	-- self.attackList:add(DataCenter.roleData.baseParam.water_power);
	-- self.attackList:add(DataCenter.roleData.baseParam.fire_power);
	-- self.attackList:add(DataCenter.roleData.baseParam.earth_power);

	self.label = UICreate.createLabel(self.content, "", -106, 15, 100, 30, 22);
	self.label.pivot = UIWidget.Pivot.TopLeft;
	self.label.overflowMethod = UILabel.Overflow.ResizeFreely;
end

function Lua_ChaoticBossAttrItem:setData(data)
	local attrLb = tostring(Lua_ThingDefine.getParamName(data.key));
	self.label.text = "[FFB319]" .. attrLb .. "：[-] [D2D8DC]" .. data.val .. "[-]";

	-- local temp = 0;
	-- for i = 1, self.attrKeyArr:getSize() do
	-- 	if self.attrKeyArr[i] == data.key then
	-- 		temp = tonumber(self.attackList[i])-tonumber(data.val);
	-- 		if temp < 0 then
	-- 			self.label.text = "[FFB319]" .. attrLb .. "：[-] [FF1616]" .. data.val .."("..temp.. ")[-]";
	-- 		end
	-- 	end
	-- end
end

function Lua_ChaoticBossAttrItem:dispose()
	if self.label ~= nil then
		self.label:dispose();
		self.label = nil;
	end

	self:superCall("dispose");
end