-- 混沌战场左侧信息栏面板
checkRequire("Lua_LeftInfoBaseWindow");
checkRequire("Lua_BossCopyInfoList");
checkRequire("Lua_BossMonsterList");
Lua_ChaoticLeftInfoWindow = class("Lua_ChaoticLeftInfoWindow", Lua_LeftInfoBaseWindow);
function Lua_ChaoticLeftInfoWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ChaoticLeftInfoWindow";
end

function Lua_ChaoticLeftInfoWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.openBuyTimeWin = false;

	self.bg = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_bg_07", 141, 181.5, 256, 241);
	self.bg.name = "bg";
	self.bg.clickScale = false;
	self.bg.pivot = UIWidget.Pivot.Top;
	self.bg:setDepth(0);
	self.bg:addClickFuntion(self, self.onBgClick);

	self.tipsLab = UICreate.createLabel(self.content, LanUtil.getValue(128613), 20, 169, 246, 30, 20);
	self.tipsLab.name = "tipsLab";
	self.tipsLab.overflowMethod = UILabel.Overflow.ResizeHeight;
	self.tipsLab.pivot = UIWidget.Pivot.TopLeft;
	self.tipsLab:setDepth(1);

	self.fenxian = UICreate.createUIAtlasImage(self.content, "common_atlas_2", "ui_common_x_06", 141, 99, 256, 2);
	self.fenxian.name = "fenxian";
	self.fenxian:setDepth(1);

	self.mapGo = UICreate.createGameObject(self.content);
	self.tipsLab2 = UICreate.createLabel(self.mapGo, LanUtil.getValue(128614), 20, 89, 246, 30, 20);
	self.tipsLab2.name = "tipsLab2";
	self.tipsLab2.overflowMethod = UILabel.Overflow.ResizeHeight;
	self.tipsLab2.pivot = UIWidget.Pivot.TopLeft;
	self.tipsLab2:setDepth(1);

	self.fenxian2 = UICreate.createUIAtlasImage(self.mapGo, "common_atlas_2", "ui_common_x_06", 141, 39, 256, 2);
	self.fenxian2.name = "fenxian2";
	self.fenxian2:setDepth(1);

	self.updataTime = UICreate.createLabel(self.mapGo, LanUtil.getValue(128615), 20, 22, 246, 30, 20);
	self.updataTime.name = "updataTime";
	self.updataTime.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.updataTime.pivot = UIWidget.Pivot.TopLeft;
	self.updataTime:setDepth(1);

	self.fenxian3 = UICreate.createUIAtlasImage(self.content, "common_atlas_2", "ui_common_x_06", 141, -15, 256, 2);
	self.fenxian3.name = "fenxian3";
	self.fenxian3:setDepth(1);

	self.bossList = Lua_BossCopyInfoList.new(self.content); -- BOSS
	self.bossList:setShowColor("[FFB319]");
	self.bossList:setSelectSize(268, 38);
	self.bossList:setLocation(141, 43, 0);

	self.monsterList = Lua_BossMonsterList.new(self.content); -- 小怪
	self.monsterList:setDraglistInfo(Vector4(0, 0, 265, 100));
	self.monsterList:setShowState(false);
	self.monsterList:setShowColor("[FFB319]");
	self.monsterList:setSelectSize(268, 38);
	self.monsterList:setLocation(141, 43, 0);

	local arr = Array();
	arr:add(LanUtil.getValue(110616));
	arr:add(LanUtil.getValue(121624));

	self.btnList = Lua_ButtonList.new(self.content, arr, 113, self, self.onButtonListClick,
		"ui_zhujiemian_title_02", "ui_zhujiemian_title_01", Vector4(0, 0, 112, 32), Vector4(0, 0, 112, 32),
		Lua_ColorDefine.transColor("F2F7FF"), Lua_ColorDefine.transColor("FFFFFF"), Vector4(22, 22, 112, 32), 2, 
		"mainWindow_atlas", Vector3(0, 0, 0), Vector3(0, 0, 0), "2D3640", "815800");
	self.btnList:setLocation(68.5, 196, 0);
	self.btnList:setDepth(5);
	self.btnList:setSelected(1, true);

	self:onSceneLoaded();
	self:setHunDunInfo();

	self:addLuaEvent("SCENE_LOADED", self, self.onSceneLoaded);
	self:addLuaEvent("MENU_OUT_CLICK", self, self.onMenuOutClick);
	self:addLuaEvent("BOSS_COPY_SCENE_INFO_UPDATE", self, self.onBossCopySceneInfoUpdate);
	self:addLuaEvent("UPDATACHAOTICTIME", self, self.updataChaoticTime);
	self:addLuaEvent("UPDATA_LIFEICON", self, self.getUpdataInfo);
	self:addLuaEvent("BOSS_DATA_INFO_UPDATE", self, self.onUpdataLifeIcon);

	self:updataChaoticTime(DataCenter.bossData.bannerTime);
	Lua_MsgUtil.callFunc("ADD_RIGHTTOP_ICON", 10110);
end

function Lua_ChaoticLeftInfoWindow.Get:hideOffset()
	return -275;
end

function Lua_ChaoticLeftInfoWindow:setShowState(val)
	self:superCall("setShowState", val);

	if val then
		self.closeBtn:setLocation(253.5, 192, 0);
		self.closeIcon:setLocation(252, 196, 0);
	else
		self.closeBtn:setLocation(259.5 + self.closeBtn.width + 13, 192, 0);
		self.closeIcon:setLocation(258 - 1.5 + self.closeBtn.width + 13, 196, 0);
	end
end

function Lua_ChaoticLeftInfoWindow:setHunDunInfo()
	local cmd = getProtoMsg("Proto10401602");
	cmd.type = Lua_BossData.TYPE_CHAOTIC_KUAFU;
	sendMsg(10401602, cmd);
end

function Lua_ChaoticLeftInfoWindow:getUpdataInfo()
	self.openBuyTimeWin = true;
	self.setHunDunInfo();
end

function Lua_ChaoticLeftInfoWindow:onUpdataLifeIcon(type)
	if self.openBuyTimeWin == true and type == Lua_BossData.TYPE_CHAOTIC_KUAFU then
		if DataCenter.bossData:getBossDetailByType(Lua_BossData.TYPE_CHAOTIC_KUAFU).leftChall == 0 then
			OperateAlert.show(LanUtil.getValue(128630));
		else
			Lua_WindowUtil.openWin("Lua_ChaoticLifeWindow", WinParam.ACTION_OPEN);
		end
	end
	self.openBuyTimeWin = false;
end

function Lua_ChaoticLeftInfoWindow:updataChaoticTime(msg)
	self.timeMsg = msg;
	if self.timeMsg ~= nil then
		self.totalTime = 0;
		DataCenter.bossData.OnUpdataZQ = false;
		if self.timeMsg.end_time ~= nil and tonumber(self.timeMsg.end_time) <= 0 then
			self.totalTime = tonumber(self.timeMsg.refresh_time);
			DataCenter.bossData.OnUpdataZQ = false;
		elseif self.timeMsg.refresh_time ~= nil and tonumber(self.timeMsg.refresh_time) <= 0 then
			self.totalTime = tonumber(self.timeMsg.end_time);
			DataCenter.bossData.OnUpdataZQ = true;
		end

		self.curTime = getTime();
		Lua_CommonUtil.removeTimer(self, self.updataZHtime);
		Lua_CommonUtil.addTimer("updataZHtime2", 0.01, self, self.updataZHtime);
		self:setHunDunInfo();
	end
end

function Lua_ChaoticLeftInfoWindow:updataZHtime()
	local num = getTime();
	self.totalTime = self.totalTime - (num - self.curTime);
	self.curTime = num;
	if tonumber(self.curSelectIdx) ~= 4 then
		local time = TimeTransform.getInstance():transSeconds1(math.ceil(self.totalTime), true);
		if DataCenter.bossData.OnUpdataZQ == true then
			self.updataTime.text = LanUtil.formateStr(LanUtil.getValue(128615), time);
		else
			self.updataTime.text = LanUtil.formateStr(LanUtil.getValue(128616), time);
		end
	end

	if self.totalTime <= 0 then
		Lua_CommonUtil.removeTimer(self, self.updataZHtime);
	end
end

function Lua_ChaoticLeftInfoWindow:onSceneLoaded()
	local sceneConfig = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
	if sceneConfig.show_monster_list == 1 and self.state == 1 then
		if self.switchIcon == nil then
			self.switchIcon = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_qiehuan", 141, -37, 0, 0);
			self.switchIcon.name = "switchIcon";
			self.switchIcon:setDepth(2);
			self.switchIcon:addClickFuntion(self, self.onSwitchClick);
		end
		self.switchIcon:setEnable(true);
		self.bg:SetDimensions(256, 241);
	else
		if self.switchIcon ~= nil then
			self.switchIcon:setEnable(false);
		end
		self.bg:SetDimensions(256, 196);
	end
end

function Lua_ChaoticLeftInfoWindow:onSwitchClick(go)
	if self.mstate == 1 then
		self.mstate = 2;
	else
		self.mstate = 1;
	end
	self:updateMonsterList();
end

function Lua_ChaoticLeftInfoWindow:updateMonsterList()
	if self.mstate == 1 then
		self.mapGo:SetActive(true);
		self.bossList:setEnable(false);
		self.monsterList:setEnable(false);

		-- self.monsterList:updateMonsterList();
		self.btnList.pageArr[1].txt.text = LanUtil.getValue(128625);
	elseif DataCenter.roleData.sceneId~=71804 then
		self.mapGo:SetActive(false);
		self.bossList:setEnable(false);
		self.monsterList:setEnable(true);

		self.monsterList:updateMonsterList();
		self.btnList.pageArr[1].txt.text = LanUtil.getValue(128626);
	else
		self.mapGo:SetActive(false);
		self.bossList:setEnable(true);
		self.monsterList:setEnable(false);

		self.btnList.pageArr[1].txt.text = LanUtil.getValue(110040);
	end
end

function Lua_ChaoticLeftInfoWindow:onMenuOutClick()
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(128633),
		type = 1, subFun = self.onOutClick});
end

function Lua_ChaoticLeftInfoWindow:onOutClick(val)
	sendMsg(10400902);
end

function Lua_ChaoticLeftInfoWindow:onBossCopySceneInfoUpdate(msg)
	self.bossList:setData(msg);
end

function Lua_ChaoticLeftInfoWindow:showWin(msg)
	if self.bossList ~= nil then
		self.bossList:setData(msg);
	end

	--BUG #7685 【boss玩法】优化：前往boss位置方式
	if DataCenter.bossData.needTrackBossId ~= nil then
		local bossId = DataCenter.bossData.needTrackBossId;
		local sceneId = DataCenter.bossData.needTrackSceneId;
		local bossDetail = nil;
		for k,v in ipairs(msg.boss_detail_set) do
			if v.monster_id == bossId then
				bossDetail = v;
				break;
			end
		end

		if #msg.boss_detail_set == 0 then
			local sceneConfig = Lua_SceneConfigData.getSceneConfig(DataCenter.roleData.sceneId);
			local monsterList = sceneConfig.config.monster;
			if monsterList ~= nil then
				for i,v in ipairs(monsterList) do
					if v.id == bossId then
						bossDetail = {pos = {pixel_x = v.posX, pixel_y = v.posY, pixel_z = v.posZ}};
						break;
					end
				end
			end
		end

		if bossDetail ~= nil then
			local tbossId = tonumber(bossId);
			local nextAction = WorldMapUtil.genArriveActionVo({type = 8,
			monsterId = Lua_CommonUtil.trnsLongNum(tbossId), dailytask = 0});
			WorldMapUtil.moveTo(sceneId, bossDetail.pos.pixel_x, bossDetail.pos.pixel_y,
				bossDetail.pos.pixel_z, 0, 0, nextAction, 0);

			DataCenter.bossData.needTrackBossId = nil;
			DataCenter.bossData.needTrackSceneId = nil;
		end
	end
end

function Lua_ChaoticLeftInfoWindow:onButtonListClick(val)
	self.state = val;
	if val == 1 then
		self:updateMonsterList();

		self.bg:setEnable(true);
		self.fenxian:setEnable(true);
		self.tipsLab:setEnable(true);
		if self._teamPanel ~= nil then
			self._teamPanel:setEnable(false);
		end
	else
		self.mapGo:SetActive(false);
		self.bg:setEnable(false);
		self.fenxian:setEnable(false);
		self.tipsLab:setEnable(false);
		self.bossList:setEnable(false);
		self.monsterList:setEnable(false);

		self.teamPanel:setEnable(true);
	end
	self:onSceneLoaded();
end

function Lua_ChaoticLeftInfoWindow.Get:teamPanel()
	if self._teamPanel == nil then
		self._teamPanel = Lua_TeamPanel.new(self.content);
		self._teamPanel:setLocation(0, 54, 0);
	end
	return self._teamPanel;
end

function Lua_ChaoticLeftInfoWindow:dispose()
	if self._teamPanel ~= nil then
		self._teamPanel:dispose();
		self._teamPanel = nil;
	end
	self.openBuyTimeWin = false;
	Lua_CommonUtil.removeTimer(self, self.updataZHtime);

	self:superCall("dispose");
end