Lua_ChaoticLifeWindow = class("Lua_ChaoticLifeWindow", Lua_Window);
function Lua_ChaoticLifeWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ChaoticLifeWindow";
	self.skinName = "ChaoticLifeWindow_skin";
end

function Lua_ChaoticLifeWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setDepth(5);
	self.itemImg:setLocation(0, -18, 0);

	self.infoTxt.text = LanUtil.getValue(128629);

	self:setItemData();

	self.subBtn:addClickFuntion(self, self.onGotoClick);
	self.cancelBtn:addClickFuntion(self, self.hide);

	self:addLuaEvent("OUTSCENE_COUNTDOWN_TIME", self, self.onOutSceneCountDown);
end

function Lua_ChaoticLifeWindow:onOutSceneCountDown(msg)
	self.outMsg = msg;
end

function Lua_ChaoticLifeWindow:setItemData()
	self.curfig = getConfig({"scene", DataCenter.roleData.sceneId});
	self.singleMoney = self.curfig.tick_money;
	
	self.toolId = self.curfig.tick_item;
	self.listData = DataCenter.bossData:getBossDetailByType(Lua_BossData.TYPE_CHAOTIC_KUAFU);
	self.conNum = tonumber(self.listData.costTicket);
	self.itemNum = 0;
	if self.toolId ~= nil and self.conNum ~= nil then
		self.itemNum = DataCenter.packData:getBagType(2):getItemNum(tonumber(self.toolId));
		self.itemImg.data = Lua_ToolVo.new(tonumber(self.toolId), self.itemNum);
		self.itemImg:showNumLimit(self.itemNum, self.conNum, 2);
	end
end

function Lua_ChaoticLifeWindow:onGotoClick(go)
	if self.outMsg ~= nil then
		if self.outMsg.left_time ~= nil and self.outMsg.type == 0 then
			OperateAlert.show(LanUtil.getValue(128638));
			self:hide();
			return;
		end
	end

	if tonumber(self.conNum) > tonumber(self.itemNum) then
		local itemName = Lua_ToolVo.createToolVo(self.toolId, 1, 1).colorName;
		Lua_WindowUtil.openWin("Lua_BossCopyBuyTimesWindow", WinParam.ACTION_OPEN, {
			type = self.curfig.boss_copy_type,
			itemName = itemName,
			leftTicket = self.itemNum,
			costTicket = self.conNum,
			scene_id = DataCenter.roleData.sceneId,
			space_id = nil,
			monster_id = nil,
			callBack = self.onSubCallback
		});
	else
		self:onSubCallback();
	end
	self:hide();
end

function Lua_ChaoticLifeWindow:onSubCallback()
	local cmd = getProtoMsg("Proto10401605");
	cmd.type = Lua_BossData.TYPE_CHAOTIC_KUAFU;
	sendMsg(10401605, cmd);
end