Lua_CopyEnterTipsWindow = class("Lua_CopyEnterTipsWindow", Lua_ThirdSizeWindow);
function Lua_CopyEnterTipsWindow:ctor()
	self:superCall("ctor", true, 3500, true, LanUtil.getValue(128634));

	self.windowName = "Lua_CopyEnterTipsWindow";
	self.skinName = "BossCopyBuyTimesWindow_skin";
	self.w = 602;
	self.h = 351;
end

function Lua_CopyEnterTipsWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.needTotalMoney = 0;
	self.costConfirmTxt:setLocation(0, 15, 0);

	self.itemImg = Lua_ToolImage.new(self.content);
	self.itemImg:setLocation(0, 70, 0);

	self.cancelBtn:addClickFuntion(self, self.hide);
	self.subBtn:addClickFuntion(self, self.onOkClick);
end

function Lua_CopyEnterTipsWindow:showWin(param)
	self.scene_id = param.scene_id;
	self.space_id = param.space_id;
	self.monster_id = param.monster_id;

	local sceneCfg = Lua_SceneConfigData.getSceneConfig(param.scene_id);
	local itemId = sceneCfg.config.tick_item;
	local leftTicket = param.leftTicket;
	local costTicket = param.costTicket;
	local tvo =  Lua_ToolVo.createToolVo(itemId, 1, 1);
	self.itemImg.data = tvo;
	self.itemImg:showNum2(leftTicket, costTicket, 2);

	local copyTypeName = "";
	if param.type == Lua_BossData.TYPE_CHAOTIC_KUAFU then
		copyTypeName = LanUtil.getValue(128631);
		self.tipsTxt:setEnable(false);
	elseif param.type == Lua_BossData.TYPE_PRIMITIVE_KUAFU then
		copyTypeName = LanUtil.getValue(140100);
		self.tipsTxt:setEnable(false);
	end

	local needBuyCount = leftTicket - costTicket;
	local tickMoney = sceneCfg.config.tick_money;
	self.needTotalMoney = tonumber(tickMoney * needBuyCount);
	--	self.costTxt.text = LanUtil.formateStr(LanUtil.getValue(121617), tostring(needBuyCount));
	self.costConfirmTxt.text = LanUtil.formateStr(LanUtil.getValue(128635), copyTypeName, tostring(costTicket), param.itemName);
end

function Lua_CopyEnterTipsWindow:onOkClick(go)
	DataCenter.bossData.needTrackBossId = self.monster_id;
	DataCenter.bossData.needTrackSceneId = tonumber(self.scene_id);

	local cmd = getProtoMsg("Proto10401601");
	cmd.scene_id = self.scene_id;
	cmd.space_id = self.space_id ;
	cmd.monster_id = self.monster_id;
	sendMsg(10401601,cmd);

	self:hide();
end