checkRequire("Lua_BossBasePanel"); -- BOSS之家
Lua_HuangLingBossPanel = class("Lua_HuangLingBossPanel", Lua_BossBasePanel);
function Lua_HuangLingBossPanel:ctor(p)
	self:superCall("ctor", p, "HuangLingBossPanel_skin", Lua_BossData.TYPE_HUANGLING);
end

function Lua_HuangLingBossPanel:buildShowItem()
	self.listW = 310;
	self.listH = 430;
	self.listX = 417;
	self.listY = -22;
	self:superCall("buildShowItem");

	self.curHLCfg = nil;
	self.listIdx = 1;
	self.layerDataDic = {};
	self.firstSetIdx = true;

	self.leftTimesTxt.text = LanUtil.getValue(121623);
	self.costTxt:setEnable(false);

	local btnNames = Array();
	self.cfgList = Array();
	self.curSelectIdx = 1;
	local hlCfg = getConfig({"RoyalScene"});
	for k,v in ipairs(hlCfg) do
		btnNames:add(v.btn_name);		
		self.cfgList:add(v);
		if v.open_level ~= nil and DataCenter.roleData.level >= v.open_level and v.vip_limit ~= nil then
			if DataCenter.vipData.level == v.vip_limit and DataCenter.vipData.level == 100 then
				self.curSelectIdx = tonumber(k);
			elseif DataCenter.vipData.level >= v.vip_limit and DataCenter.vipData.level ~= 100 then
				self.curSelectIdx = tonumber(k);
			end
		end
	end
	self.btnList = Lua_ButtonList.new(self.content, btnNames, 125.5, self, self.onBtnClick,
		"ui_common_btn_c2", "ui_common_btn_c1", Vector4(0, 0, 118, 53), Vector4(0, 0, 118, 53),
		Lua_ColorDefine.transColor("D2D8DC"), Lua_ColorDefine.transColor("FFFFFF"), Vector4(24, 24, 118, 30), 2, "common_atlas_1");
	self.btnList:setDepth(10);
	self.btnList:setLocation(-276, 234, 0);
	self.btnList:setSelected(self.curSelectIdx, false);

	self.gotoBtn:addClickFuntion(self,self.onGotoClick);

	self:setGotoBtnLabel();
end

function Lua_HuangLingBossPanel:onGotoClick(go)
	if self.curHLCfg == nil then
		return;
	end
	local firstFloorCfg = self.cfgList[1];
	
	local curVipVo = getConfig({"vip_level",DataCenter.vipData.level});
	if curVipVo~= nil and curVipVo.huangling == nil then
		-- 先检查vip是否符合第一层的vip等级要求，如果不符合，优先弹查看vip提示弹框。
		local vipcfg = getConfig({"vip_level"});
		local vipName = "";
		for k,v in ipairs(vipcfg) do
			if v.huangling ~= nil then
				vipName = v.name;
				break;
			end
		end
		local tipsContent = LanUtil.formateStr(LanUtil.getValue(121639), tostring(vipName), firstFloorCfg.name);
		Lua_WindowUtil.openWin("Lua_BossEnterCheckVipTips", nil, tipsContent);
		return;
	end
	
	if curVipVo ~= nil and curVipVo.huangling ~= nil then
		local canIn = false;
		for k,v in ipairs(curVipVo.huangling) do
			
			if tonumber(v) == tonumber(self.curSelectIdx) then
				canIn = true;
				break;
			end
		end

		if canIn == false then
			local tipData = {};
			tipData.des =LanUtil.formateStr(LanUtil.getValue(121637), tostring(self.curHLCfg.need_money), tostring(self.curSelectIdx));  
			tipData.owner = self;
			tipData.type = 1;
			tipData.subFun = self.checkEnterBossScene;   --确定
			Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
			return;
		end
	end
	self:checkEnterBossScene();
end

function Lua_HuangLingBossPanel:checkEnterBossScene()
	local challCount = self.listData.totalChall-self.listData.leftChall;
	local hlLayerCfg = getConfig({"RoyalScene", self.curSelectIdx});	
	if hlLayerCfg ~= nil then
		DataCenter.bossData:sEnterBossScene(challCount, self.listData.totalChall, self.itemData.is_live, self.itemData.monster_id, self.curSelectIdx, hlLayerCfg.scene_id, false);
	end
end

function Lua_HuangLingBossPanel:onRuleClick()
	self:superCall("onRuleClick");
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", nil, LanUtil.getValue(121630));
end

function Lua_HuangLingBossPanel:updateDetailInfo(type)
	if type ~= self.type then
		return;
	end
	self.listData = DataCenter.bossData:getBossDetailByType(type);
	
	self:clearLayerDataList();
	self.layerDataDic = {};
	self.dataList:clear();	
		
	for k,v in ipairs(self.listData.bossDetailSet) do
		if self.layerDataDic[tostring(v.layer)] == nil then
			 self.layerDataDic[tostring(v.layer)] = Array();
		end
		self.layerDataDic[tostring(v.layer)]:add(v);
	end
	
	--升序排序
	for k,v in pairs(self.layerDataDic) do
		v:sort("lvl", false);
	end

	if DataCenter.bossData.checkBossId ~= nil then 
		self:getMonsterIdLayer(DataCenter.bossData.checkBossId);
		self.needSetIdx = true;
		DataCenter.bossData.checkBossId = nil;
	end

	local tlist = self.layerDataDic[tostring(self.curSelectIdx)]
	if tlist ~= nil then
		self.dragList:setLuaArrayData(tlist, false);
		local idx = 1;
		if tlist:getSize() > 0 then
			idx = self.listIdx;
		end

		if self.needSetIdx == true then
			idx = self.monsterIndex;
			self.needSetIdx = false;
		end

		if self.firstSetIdx == true then
			self.dragList:moveToIndex(idx,true);
			self.dragList:setSelected(idx);
			self.firstSetIdx = false;
		end
	end
end

function Lua_HuangLingBossPanel:clearLayerDataList()
	if self.layerDataDic ~= nil then
		while #self.layerDataDic >0 do
			self.layerDataDic[1]:clear();
			table.remove(self.layerDataDic,1);
		end
	end
end

function Lua_HuangLingBossPanel:onListItemClick(itemData)
	self:superCall("onListItemClick", itemData);

	self.firstSetIdx = true;
	self.listIdx = self.dragList.curSelectedIdx;	
end

function Lua_HuangLingBossPanel:onLayerClick(itemData)
end

function Lua_HuangLingBossPanel:onBtnClick(val)
	if self.curSelectIdx ~= val then
		self.listIdx = 1;
	end
	self.curSelectIdx = val;
	
	self:setGotoBtnLabel();
	
	local tlist = self.layerDataDic[tostring(self.curSelectIdx)]
	if tlist ~= nil then
		self.dragList:setLuaArrayData(tlist, false);
		if tlist:getSize() > 0 then
			self.dragList:moveToIndex(self.listIdx,true);
			self.dragList:setSelected(self.listIdx);
		end
	end
end

function Lua_HuangLingBossPanel:setGotoBtnLabel()
	self.curHLCfg = self.cfgList[self.curSelectIdx];
	local needVip = self.curHLCfg.vip_limit;	
	local vipLv = DataCenter.vipData.level;
	local curVipVo = getConfig({"vip_level",DataCenter.vipData.level});
	local canIn = false; 
	if DataCenter.vipData.level~=0 then
		for k,v in ipairs(curVipVo.huangling) do
			if tonumber(v) == tonumber(self.curSelectIdx) then
				canIn = true;
				break;
			end
		end
	end

	if canIn == true then
		self.gotoBtn.label = LanUtil.getValue(110917);
		self.ruleTxt.text = "";
	else
		local name = getConfig( { "vip_level", needVip, "view_name"});
			if getLanType() == 2 and tonumber(needVip) == 100 then
				self.gotoBtn.label = "會員前往";
			else
				self.gotoBtn.label = LanUtil.formateStr(LanUtil.getValue(121636), name);
			end
		if self.curHLCfg.need_money ~= nil then
			self.ruleTxt.text = LanUtil.formateStr(LanUtil.getValue(121672), tostring(self.curHLCfg.need_money));
		else
			self.ruleTxt.text = "";
		end
	end
end

-- 用于图鉴功能--通过bossID 让光标移到对应boss
function Lua_HuangLingBossPanel:getMonsterIdLayer(monsterId)
	local list =self.listData.bossDetailSet;
	if list == nil then
		return;
	end

	for k,v in ipairs(list) do
		if v.monster_id == monsterId then
			self.monsterLayer = v.layer;
			break;
		end
	end

	local arr =  self.layerDataDic[tostring(self.monsterLayer)];
	for i=1,arr:getSize() do
		if arr[i].monster_id == monsterId then
			self.monsterIndex = i;
			self.monsterLayer = arr[i].layer;
			break;
		end
	end
	self:onBtnClick(self.monsterLayer);
	self.btnList:setSelected(self.monsterLayer, false)
end