-- 神兽岛左侧信息栏Item
Lua_IsleBossCopyInfoItem = class("Lua_IsleBossCopyInfoItem", Lua_ListCell);
function Lua_IsleBossCopyInfoItem:ctor(p)
	self:superCall("ctor", p, "IsleBossCopyInfoItem_skin");
end

function Lua_IsleBossCopyInfoItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_IsleBossCopyInfoItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.cfg = getConfig({"monster", data.msgData.monster_id});
	if self.cfg == nil then
		return;
	end

	Lua_CommonUtil.removeTimer(self, self.reliveCountdown);
	if self.cfg.monster_type == nil or self.cfg.monster_type == 0 or self.cfg.monster_type >= 1 and self.cfg.monster_type <= 9 then
		self.midLab:setLocation(-13, 0, 0);

		self.endTime = DataCenter.bossData.bossCopyReliveSecDic[tostring(data.msgData.monster_id)];
		self:addTimer("Lua_IsleBossCopyInfoItem_1".. data.msgData.monster_id, 0.1, self, self.reliveCountdown);

		local leftColorStr = data.colorStr == nil and "[85A8BE]" or data.colorStr;
		local midColorStr = data.colorStr == nil and "[85A8BE]" or data.colorStr;
		self.leftLab.text = leftColorStr.. self.cfg.name .."[-]";
		self.midLab.text = midColorStr.. data.msgData.cur_monster_count .."[-]";
		self.rightLab.text = "[00E125]".. TimeTransform.getInstance():transSeconds6(self.endTime - getTime(), true, true) .."[-]";
	elseif self.cfg.monster_type >= 100 then
		self.midLab:setLocation(-42, 0, 0);

		local leftColorStr;
		local midColorStr;
		local rightColorStr;
		local textStr;
		if data.msgData.is_live == 1 then
			leftColorStr = data.colorStr == nil and "[85A8BE]" or data.colorStr;
			midColorStr = data.colorStr == nil and "[85A8BE]" or data.colorStr;
			rightColorStr = "[00E125]";
			textStr = LanUtil.getValue(121627);
		else
			leftColorStr = "[FF1616]";
			midColorStr = "[FF1616]";
			rightColorStr = "[FF1616]";

			self.endTime = DataCenter.bossData.bossCopyReliveSecDic[tostring(data.msgData.monster_id)];
			textStr = TimeTransform.getInstance():transSeconds6(self.endTime - getTime(), true, true);
			self:addTimer("Lua_IsleBossCopyInfoItem_2" .. tostring(data.msgData.monster_id), 0.1, self, self.reliveCountdown);
		end
		self.leftLab.text = leftColorStr .."Lv".. data.msgData.lvl .."[-]";
		self.midLab.text = midColorStr .."[u][url=".. data.msgData.monster_id .."]".. self.cfg.name .."[/url][/u][-]";
		self.rightLab.text = rightColorStr .. textStr .."[-]";
	end

	local width = data.width == nil and 268 or data.width;
	local height = data.height == nil and 57 or data.height;
	self.selectIcon:SetDimensions(width, height);
	self.selectIcon:setEnable(data.selected);
end

function Lua_IsleBossCopyInfoItem:reliveCountdown()
	if getTime() > self.endTime then
		Lua_CommonUtil.removeTimer(self, self.reliveCountdown);
	else
		if self.cfg.monster_type == nil or self.cfg.monster_type == 0 or self.cfg.monster_type >= 1 and self.cfg.monster_type <= 9 then
			self.rightLab.text = "[00E125]".. TimeTransform.getInstance():transSeconds6(self.endTime - getTime(), true, true) .."[-]";
		elseif self.cfg.monster_type >= 100 then
			self.rightLab.text = "[FF1616]".. TimeTransform.getInstance():transSeconds6(self.endTime - getTime(), true, true) .."[-]";
		end
	end
end

function Lua_IsleBossCopyInfoItem:onPlayerSoundClick()
	local url = self.midLab:getUrlByMousePos();
	if url ~= nil then
		local rolePlayer = ThingUtil.instance:getThingById(DataCenter.roleData.roleId);
		if rolePlayer ~= nil and self._data ~= nil then
			if GlobalVar.hooking == true then
				DataCenter.hook:stop(true);
			end
			local monsterId = tonumber(self._data.msgData.monster_id);
			local nextAction = WorldMapUtil.genArriveActionVo({type = 8, monsterId = Lua_CommonUtil.trnsLongNum(monsterId), dailytask = 0});
			WorldMapUtil.moveTo(self._data.msgData.scene_id,
			self._data.msgData.pos.pixel_x, self._data.msgData.pos.pixel_y, self._data.msgData.pos.pixel_z, 0, 0, nextAction, 0);
		end
	end
	Lua_MsgUtil.callFunc("BossCopyInfo_CLICK", self._data);
end

function Lua_IsleBossCopyInfoItem:dispose()
	self._data = nil;
	Lua_CommonUtil.removeTimer(self, self.reliveCountdown);

	self:superCall("dispose");
end