-- 神兽岛左侧信息栏面板
checkRequire("Lua_LeftInfoBaseWindow");
checkRequire("Lua_BossCopyInfoList");
Lua_IsleBossCopyInfoWindow = class("Lua_IsleBossCopyInfoWindow", Lua_LeftInfoBaseWindow)
function Lua_IsleBossCopyInfoWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_IsleBossCopyInfoWindow";
end

function Lua_IsleBossCopyInfoWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.bg = UICreate.createUIAtlasImage(self.content, "mainWindow_atlas", "ui_zhujiemian_bg_07", 141, 61, 256, 241);
	self.bg.name = "bg";
	self.bg:setDepth(0);

	self.bossList = Lua_BossCopyInfoList.new(self.content);
	self.bossList:setLocation(141, 61, 0);

	local arr = Array();
	arr:add(LanUtil.getValue(110616));
	arr:add(LanUtil.getValue(121624));

	self.btnList = Lua_ButtonList.new(self.content, arr, 113, self, self.onButtonListClick,
		"ui_zhujiemian_title_02", "ui_zhujiemian_title_01", Vector4(0, 0, 112, 32), Vector4(0, 0, 112, 32),
		Lua_ColorDefine.transColor("F2F7FF"), Lua_ColorDefine.transColor("FFFFFF"), Vector4(22, 22, 112, 32), 2, 
		"mainWindow_atlas", Vector3(0, 0, 0), Vector3(0, 0, 0), "2D3640", "815800");
	self.btnList:setLocation(68.5, 196, 0);
	self.btnList:setDepth(5);
	self.btnList:setSelected(1, true);

	self:addLuaEvent("MENU_OUT_CLICK", self, self.onMenuOutClick);
	self:addLuaEvent("BOSS_COPY_SCENE_INFO_UPDATE", self, self.onBossCopySceneInfoUpdate);
end

function Lua_IsleBossCopyInfoWindow:showWin(msg)
	if self.bossList ~= nil then
		self.bossList:setData(msg);
	end
	-- BUG #7685 【boss玩法】优化：前往boss位置方式
	if DataCenter.bossData.needTrackBossId ~= nil then
		local bossId = DataCenter.bossData.needTrackBossId;
		local sceneId = DataCenter.bossData.needTrackSceneId;
		local bossDetail = nil;
		for k, v in ipairs(msg.boss_detail_set) do
			if v.monster_id == bossId then
				bossDetail = v;
				break;
			end
		end

		if bossDetail ~= nil then
			if bossDetail.pos.pixel_x == 1 and bossDetail.pos.pixel_y == 1 and bossDetail.pos.pixel_z == 1 then
				return;
			end
			local tbossId = tonumber(bossId);
			local nextAction = WorldMapUtil.genArriveActionVo({type = 8, monsterId = Lua_CommonUtil.trnsLongNum(tbossId), dailytask = 0});
			WorldMapUtil.moveTo(sceneId, bossDetail.pos.pixel_x, bossDetail.pos.pixel_y, bossDetail.pos.pixel_z, 0, 0, nextAction, 0);
			DataCenter.bossData.needTrackBossId = nil;
			DataCenter.bossData.needTrackSceneId = nil;
		end
	end
end

function Lua_IsleBossCopyInfoWindow.Get:hideOffset()
	return -275;
end

function Lua_IsleBossCopyInfoWindow:setShowState(val)
	self:superCall("setShowState", val);

	if val then
		self.closeBtn:setLocation(253.5, 192, 0);
		self.closeIcon:setLocation(252, 196, 0);
	else
		self.closeBtn:setLocation(259.5 + self.closeBtn.width + 13, 192, 0);
		self.closeIcon:setLocation(258 - 1.5 + self.closeBtn.width + 13, 196, 0);
	end
end

function Lua_IsleBossCopyInfoWindow:onMenuOutClick(o)
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(121635), type = 1, subFun = self.onOutClick});
end

function Lua_IsleBossCopyInfoWindow:onOutClick(val)
	sendMsg(10400902);
	Lua_WindowUtil.openWin("Lua_ChatWindow", WinParam.ACTION_CLOSE);
end

function Lua_IsleBossCopyInfoWindow:onBossCopySceneInfoUpdate(msg)
	self.bossList:setData(msg);
end

function Lua_IsleBossCopyInfoWindow:onButtonListClick(val)
	if val == 1 then
		self.bg:setEnable(true);
		self.bossList:setEnable(true);
		if self._teamPanel ~= nil then
			self._teamPanel:setEnable(false);
		end
	else
		self.bg:setEnable(false);
		self.bossList:setEnable(false);
		self.teamPanel:setEnable(true);
	end
end

function Lua_IsleBossCopyInfoWindow.Get:teamPanel()
	if self._teamPanel == nil then
		self._teamPanel = Lua_TeamPanel.new(self.content);
		self._teamPanel:setLocation(0, 54, 0);
	end
	return self._teamPanel;
end

function Lua_IsleBossCopyInfoWindow:dispose()
	if self.bg ~= nil then
		self.bg:dispose();
		self.bg = nil;
	end
	if self.bossList ~= nil then
		self.bossList:dispose();
		self.bossList = nil;
	end
	if self.btnList ~= nil then
		self.btnList:dispose();
		self.btnList = nil;
	end
	if self._teamPanel ~= nil then
		self._teamPanel:dispose();
		self._teamPanel = nil;
	end

	self:superCall("dispose");
end