-- 神兽岛
checkRequire("Lua_BossBasePanel");
Lua_IsleBossPanel = class("Lua_IsleBossPanel", Lua_BossBasePanel);
function Lua_IsleBossPanel:ctor(p)
    local panelType = Lua_BossData.TYPE_ISLE_BOSS; -- 神兽岛
    if WindowMananger.getInstance():isWindowShowing("Lua_BossMainWindow") == false then
        panelType = Lua_BossData.TYPE_ISLEBOSS_KUAFU; -- 神兽岛（跨服）
    end
    self.panelType = panelType;
    self:superCall("ctor", p, "IsleBossPanel_skin", panelType);
end

function Lua_IsleBossPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.costTxt:setEnable(false);

	self.listIdx = 1;
	self.firstSetIdx = true;

	if self.type == Lua_BossData.TYPE_ISLEBOSS_KUAFU then
		local hlCfg = getConfig({"tv_god_scene"});
		local arr = Array();
		self.cfgList = Array();
		for k,v in ipairs(hlCfg) do
			arr:add(v.btn_name);
			self.cfgList:add(v);
		end

		self.btnList = Lua_ButtonList.new(self.content, arr, 125.5, self, self.onBtnClick,
			"ui_common_btn_c2", "ui_common_btn_c1", Vector4(0, 0, 118, 53), Vector4(0, 0, 118, 53),
			Lua_ColorDefine.transColor("D2D8DC"), Lua_ColorDefine.transColor("FFFFFF"), Vector4(24, 24, 118, 30), 2, "common_atlas_1");
		self.btnList:setLocation(-276, 234, 0);
		self.btnList:setDepth(10);
		self.btnList:setSelected(1, false);

		self.nameBg:setLocation(-284, 97);
		self.nameTxt:setLocation(-284, 97);
	end

	self.gotoBtn.label = LanUtil.getValue(110917);
	self.gotoBtn:addClickFuntion(self, self.onGotoClick);

	self:showInfoType(-1);
end

function Lua_IsleBossPanel:onBtnClick(val)
	local tempcur = false;
	if self.curSelectIdx ~= val then
		tempcur = true;
	end
	self.curSelectIdx = val;

	local tlist = self.layerDataDic[tostring(self.curSelectIdx)]
	if tlist ~= nil then
		self.dragList:setLuaArrayData(tlist, false);
		if tlist:getSize() > 0 then
			if self.tempcur ~= nil and self.tempcur ~= val then
				self.listIdx = 1;
			end

			if tempcur == true then
				self.dragList:moveToIndex(1,true);
				self.dragList:setSelected(1);
			else
				self.dragList:moveToIndex(self.listIdx,true);
				self.dragList:setSelected(self.listIdx);
			end
		end
	end

	if self.cfgList[val].open_level ~= nil and  DataCenter.roleData.level < tonumber(self.cfgList[val].open_level) then
		OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(121673), tostring(val), tostring(self.cfgList[val].open_level)));
	end
end

function Lua_IsleBossPanel:onGotoClick()
	if self.itemData == nil then
		return;
	end

	if self.type == Lua_BossData.TYPE_ISLEBOSS_KUAFU and self.cfgList[self.curSelectIdx].open_level ~= nil
		and DataCenter.roleData.level < tonumber(self.cfgList[self.curSelectIdx].open_level) then
		OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(121673), tostring(self.curSelectIdx), tostring(self.cfgList[self.curSelectIdx].open_level)));
		return;
	end
	self:checkTimes();
end

function Lua_IsleBossPanel:checkTimes()
	if self.listData.leftChall <= 0 then
		local tipData = {};
		tipData.des = LanUtil.getValue(121662)
		tipData.owner = self;
		tipData.type = 1;
		tipData.subFun = self.doSendEnterBossScene;
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
		return;
	end
	self:doSendEnterBossScene();
end

function Lua_IsleBossPanel:doSendEnterBossScene()
	self:superCall("doSendEnterBossScene");
	if GlobalVar.hooking == true then
		DataCenter.hook:stop(true);
	end
	local challCount = self.listData.totalChall - self.listData.leftChall;
	DataCenter.bossData:sEnterBossScene(challCount, self.listData.totalChall, self.itemData.is_live, self.itemData.monster_id, self.itemData.space_id, self.itemData.scene_id, false);
end

function Lua_IsleBossPanel:updateDetailInfo(type)
	self:superCall("updateDetailInfo", type);

	if self.firstSetIdx == true then
		self.dragList:moveToIndex(1, true);
		self.dragList:setSelected(1);
		self.firstSetIdx = false;
	end
end

function Lua_IsleBossPanel:onListItemClick(itemData)
	self:superCall("onListItemClick", itemData);

	self:showInfoType(self.curCfg.monster_type);
	self.listIdx = self.dragList.curSelectedIdx;
end

function Lua_IsleBossPanel:onRuleClick()
	self:superCall("onRuleClick");

	local str = LanUtil.getValue(121660)
	if self.type == Lua_BossData.TYPE_ISLEBOSS_KUAFU then
		str = LanUtil.getValue(121667);
	end
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", nil, str);
end

-- type:nil，都不显示 0，小怪 1~9，采集物 大于100，boss类型
function Lua_IsleBossPanel:showInfoType(type)
	if type == nil or type == 0 then
		self:showBossInfo(false);
		self:showOtherInfo(true, type);
		self.leftTimesTxt:setEnable(false);
	elseif type >= 1 and type <= 9 then
		self:showBossInfo(false);
		self:showOtherInfo(true, type);
		self.leftTimesTxt:setEnable(true);
	elseif type >= 101 then
		self:showBossInfo(true);
		self:showOtherInfo(false);
		self.leftTimesTxt:setEnable(true);
	else
		self:showBossInfo(false);
		self:showOtherInfo(false);
		self.leftTimesTxt:setEnable(false);
	end
	self:setLeftTimes(type);
end

function Lua_IsleBossPanel:setLeftTimes(type)
	if type == nil or type == 0 then
		self.leftTimesTxt:setEnable(false);
	elseif type >= 1 and type <= 9 then
		local leftTime = self.itemData.gather_count.obj_id;
		if DataCenter.bossData.curOpenUIType == Lua_BossData.TYPE_ISLEBOSS_KUAFU then
			local config = getConfig({"tv_god_monster", self.itemData.monster_id});
			if config ~= nil and config.limit_sort ~= nil then
				for k,v in pairs(self.layerDataDic) do
					local isFind = 0;
					for i = 1, v:getSize() do
						if tonumber(v[i].monster_id) == tonumber(config.limit_sort) then
							leftTime = v[i].gather_count.obj_id;
							isFind = 1;
							break;
						end
					end

					if isFind == 1 then
						break;
					end
				end
			end
		end
		self.leftTimesTxt.text = LanUtil.getValue(121658) .. ":" .. tostring(leftTime) .. "/" .. tostring(self.itemData.gather_count.obj_value);
	elseif type >= 101 then
		self.leftTimesTxt.text = LanUtil.getValue(121659) .. ":" .. tostring(self.listData.totalChall - self.listData.leftChall) .. "/" .. tostring(self.listData.totalChall);
	end
end

function Lua_IsleBossPanel:showBossInfo(isShow)
	self.killRecordBg:setEnable(isShow);
	self.killRecordBtn:setEnable(isShow);
	self.bossAtrrBg:setEnable(isShow);
	self.bossAtrrBtn:setEnable(isShow);
	self.bornTxt:setEnable(isShow);
	self.dropTitleBg:setEnable(isShow);
	self.followChk:setEnable(isShow);

	if isShow then
		self.bossAtrrBtn:setAltas("boss_atlas", self.showingAttr == true and "ui_boss_icon_4" or "ui_boss_icon_2");
		self.attrTextcontainer:SetActive(self.showingAttr);
		self.rItem:setEnable(not self.showingAttr);
		if self.dropTitleTxt ~= nil then
			self.dropTitleTxt:setEnable(true);
			self.dropTitleTxt.text = self.showingAttr == true and LanUtil.getValue(121650) or LanUtil.getValue(121649);
		end
	else
		self.attrTextcontainer:SetActive(false);
		self.rItem:setEnable(false);
		if self.dropTitleTxt ~= nil then
			self.dropTitleTxt:setEnable(false);
		end
	end
end

function Lua_IsleBossPanel:showOtherInfo(isShow, type)
	if isShow then
		if self.otherInfoObj == nil then
			self.otherInfoObj = UICreate.createGameObject(self.content, -47, -147, 0);
			self.otherInfoObj.name = "otherInfoObj";

			self.infoTxt1 = UICreate.createLabel(self.otherInfoObj, "", 0, 25, 428, 30, 24);
			self.infoTxt1.overflowMethod = UILabel.Overflow.ResizeFreely;
			self.infoTxt1.pivot = UIWidget.Pivot.Center;
			self.infoTxt1.depth = 4;

			self.infoTxt2 = UICreate.createLabel(self.otherInfoObj, "", 0, -25, 428, 30, 24);
			self.infoTxt2.overflowMethod = UILabel.Overflow.ResizeFreely;
			self.infoTxt2.pivot = UIWidget.Pivot.Center;
			self.infoTxt2.depth = 4;
		else
			self.otherInfoObj:SetActive(true);
		end

		if type == nil or type == 0 then
			self.infoTxt1.text = LanUtil.getValue(121654);
			if self.panelType == Lua_BossData.TYPE_ISLEBOSS_KUAFU then
				self.infoTxt1.text = LanUtil.getValue(121669);
			end
			self.infoTxt2.text = LanUtil.formateStr(LanUtil.getValue(121656), tostring(self.itemData.cur_monster_count));
		elseif type >= 1 and type <= 9 then
			self.infoTxt1.text = LanUtil.getValue(121655);
			if self.panelType == Lua_BossData.TYPE_ISLEBOSS_KUAFU then
				self.infoTxt1.text = LanUtil.getValue(121670);
			end
			self.infoTxt2.text = LanUtil.formateStr(LanUtil.getValue(121657), tostring(self.itemData.cur_monster_count));
		end
	else
		if self.otherInfoObj ~= nil then
			self.otherInfoObj:SetActive(false);
		end
	end
end