-- 限时BOSS
checkRequire("Lua_LeftInfoBaseWindow");
Lua_LimitTimeBossRageWindow = class("Lua_LimitTimeBossRageWindow", Lua_LeftInfoBaseWindow);
function Lua_LimitTimeBossRageWindow:ctor()
	self:superCall("ctor")

	self.skinName = "LimitTimeBossRageWindow_skin";
	self.windowName = "Lua_LimitTimeBossRageWindow";
end

function Lua_LimitTimeBossRageWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.closeBtn:setEnable(false);
	self.closeIcon:setEnable(false);

	self.rbg.clickScale = false;
	self.rbg:addClickFuntion(self, self.onRuleClick);

	self:onRageUpdate();

	self:addLuaEvent("LIMITTIME_BOSS_RAGE_UPDATE", self, self.onRageUpdate);
	self:addLuaEvent("SHOWORHIDE_LIMITTIME", self, self.showOrHideWindow);
end

function Lua_LimitTimeBossRageWindow:onRageUpdate()
	local curValue = DataCenter.bossData.angerPoint;
	local maxValue = DataCenter.bossData.angerMax;
	local rageType = DataCenter.bossData.rageType;
	if rageType == Lua_BossData.TYPE_CHAOTIC_KUAFU then
		maxValue = 100;

		self.rageBar:setBarBgAtlas("bossWindow", "energyBg"); -- hdzc_03
		self.rbg:setAltas("bossWindow", "energyBg");
		self.rageLabel.text = LanUtil.getValue(128627);

		local curCfg = getConfig({"boss_base_info", "hundun_energy_limit"});
		if curCfg.val ~= nil and curValue < tonumber(curCfg.val) then
			if self.rageEffect == nil then
				self.rageEffect = UICreate.createUIEffect(self.content, "/effects/scsEffects/hdzc_03", "hdzc_03", 0, 0);
				self.rageEffect:SetRenderQueue(self.rbg, 5, 2,false);
			else
				self.rageEffect:setEnable(true);
			end
		else
			if self.rageEffect ~= nil then
				self.rageEffect:dispose();
				self.rageEffect = nil;
			end
		end

		if curValue <= 0 then
			Lua_MsgUtil.callFunc("REMOVE_RIGHTTOP_ICON", 10110);
		elseif curCfg.val ~= nil and curValue < tonumber(curCfg.val)
			and DataCenter.bossData:getBossDetailByType(Lua_BossData.TYPE_CHAOTIC_KUAFU).leftChall ~= 0 then
			Lua_MsgUtil.callFunc("SHOW_HIDE_ICON_EFFECT", {iconId = 10110, isShow = true});
		elseif DataCenter.bossData:getBossDetailByType(Lua_BossData.TYPE_CHAOTIC_KUAFU).leftChall == 0 then
			Lua_MsgUtil.callFunc("SHOW_HIDE_ICON_EFFECT", {iconId = 10110, isShow = false});
		end
	end

	if DataCenter.bossData.rageType == Lua_BossData.TYPE_PRIMITIVE_KUAFU then
		self.rageBar:setBarBgAtlas("bossWindow", "fairyBg"); -- hdzc_03
		self.rbg:setAltas("bossWindow", "fairyBg")
		self.rageLabel.text = LanUtil.getValue(140111);
	end
	self.rageBar:setNumTxtOffset(53, -34);
	self.rageBar:setBarPosOffset(-68, -52);
	self.rageBar:setNumTxtSize(52, 20);
	self.rageBar:setText(tostring(curValue));
	self.rageBar:setMaxValue(maxValue);
	self.rageBar:setValue(curValue);
end

function Lua_LimitTimeBossRageWindow:showOrHideWindow(state)
	self:setShowState(state);
end

function Lua_LimitTimeBossRageWindow:onRuleClick(o)
	if DataCenter.bossData.rageType == Lua_BossData.TYPE_CHAOTIC_KUAFU then
		Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(128628));
	elseif DataCenter.bossData.rageType == Lua_BossData.TYPE_PRIMITIVE_KUAFU then
		Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(140110));
	else
		Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(121663));
	end
end

function Lua_LimitTimeBossRageWindow.Get:offsetWidth()
	return 340;
end

function Lua_LimitTimeBossRageWindow.Get:offsetHeight()
	return 113;
end

function Lua_LimitTimeBossRageWindow:dispose()
	if Lua_WindowUtil.isWindowShowing("Lua_ThurderCountWindow") then
		Lua_WindowUtil.openWin("Lua_ThurderCountWindow", WinParam.ACTION_CLOSE);
	end
	self:superCall("dispose");
end