Lua_PersonalBossCopyInfoItem = class("Lua_PersonalBossCopyInfoItem",Lua_DisplayObject)
function Lua_PersonalBossCopyInfoItem:ctor(p)
	self:superCall("ctor", p, "PersonalBossCopyInfoItem_skin");
end

function Lua_PersonalBossCopyInfoItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_PersonalBossCopyInfoItem:setData(msg)
	self.data = msg;

	if self.data.boss_detail_set == nil or #self.data.boss_detail_set == 0 then
		return;
	end

	self.bossDetail = self.data.boss_detail_set[1];
	self.cfg = getConfig({"monster", self.bossDetail.monster_id});
	if self.cfg == nil then
		return;
	end
	
	if tonumber(DataCenter.roleData.sceneId) == 90202 then
		self.descTxt:setEnable(true);
		self.descTxt.text = LanUtil.getValue(121652);
	else
		self.descTxt:setEnable(false);
	end
	if self.bossDetail.is_live == 1 then
		self.bossName.text = "Lv"..tostring(self.bossDetail.lvl).."  [00E125][u][url="..tostring(self.bossDetail.monster_id).."]"..self.cfg.name.."[/url][/u][-] ";
		self.bossName:addClickFuntion(self,self.onPlayerSoundClick);
		self.bossName.clickScale = false;
	else
		self.bossName:removeClickFuntion(self,self.onPlayerSoundClick);
		self.bossName.text = "[808080]Lv"..tostring(self.bossDetail.lvl).." "..self.cfg.name.."[-]";
	end

	self.endTime = nil;
	Lua_CommonUtil.removeTimer(self,self.leaveCountDown);
	if self.data.left_time > 0 then
		self.endTime  = getTime() + self.data.left_time;
		Lua_CommonUtil.addTimer("leaveCountDown", 0.3, self, self.leaveCountDown);
	end
end

function Lua_PersonalBossCopyInfoItem:leaveCountDown()
	if self.endTime ~= nil and self.endTime >= getTime() then
		self.endTimeTxt.text = TimeTransform.getInstance():transSeconds6(self.endTime - getTime(), true, true);
	else
		Lua_CommonUtil.removeTimer(self, self.leaveCountDown);
	end
end

function Lua_PersonalBossCopyInfoItem:onPlayerSoundClick()
	local url = self.bossName:getUrlByMousePos();
	if url ~= nil then
		local rolePlayer = ThingUtil.instance:getThingById(DataCenter.roleData.roleId);
		if rolePlayer ~= nil and self.bossDetail ~= nil then
			local monsterId = tonumber(self.bossDetail.monster_id);
			local nextAction = WorldMapUtil.genArriveActionVo({type = 8, monsterId = Lua_CommonUtil.trnsLongNum(monsterId), dailytask = 0});
			WorldMapUtil.moveTo(DataCenter.roleData.sceneId, self.bossDetail.pos.pixel_x, self.bossDetail.pos.pixel_y, self.bossDetail.pos.pixel_z, 0, 0, nextAction, 0);
		end
	end
end

function Lua_PersonalBossCopyInfoItem:dispose()
	Lua_CommonUtil.removeTimer(self,self.leaveCountDown);
	self:superCall("dispose");
end