-- 个人BOSS
checkRequire("Lua_BossBasePanel");
Lua_PersonalBossPanel = class("Lua_PersonalBossPanel", Lua_BossBasePanel);
function Lua_PersonalBossPanel:ctor(p)
	self:superCall("ctor", p, "PersonalBossPanel_skin", Lua_BossData.TYPE_PERSONAL);
end

function Lua_PersonalBossPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.costTxt:setLocation(-150, -286, 0);
	
	self.gotoBtn.label = LanUtil.getValue(121613);

	self.killRecordBg:setEnable(false);
	self.killRecordBtn:setEnable(false);
	self.followChk:setEnable(false);

	self.gotoBtn:addClickFuntion(self, self.onGotoClick);
end

function Lua_PersonalBossPanel:onListItemClick(itemData)
	self:superCall("onListItemClick", itemData);

	local sceneCfg = Lua_SceneConfigData.getSceneConfig(90201);
	if sceneCfg ~= nil and sceneCfg.config ~= nil and sceneCfg.config.tick_item ~= nil then
		local toolVo = Lua_ToolVo.createToolVo(sceneCfg.config.tick_item );
		local itemNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(sceneCfg.config.tick_item);
		self.costTxt.text = LanUtil.formateStr(LanUtil.getValue(121642), toolVo.name)..itemNum.."/"..self.listData.costTicket;
	else
		self.costTxt.text = "";
	end
end

function Lua_PersonalBossPanel:updateDetailInfo(type)
	self:superCall("updateDetailInfo", type);

	if self.listData ~= nil then
		self.leftTimesTxt.text = LanUtil.getValue(121640)..":"..tostring(self.listData.leftChall).."/"..tostring(self.listData.totalChall);
	end
	
	local myLv = DataCenter.roleData.level;
	local len = self.dataList:getSize();
	local sceneCfg = Lua_SceneConfigData.getSceneConfig(90201);
	local monsterList = sceneCfg.config.monster;
	local curMaxLv = nil;
	local curIdx = 1;
	for i = 1, len do
		local tdata = self.dataList[i];
		local enterLv = 0;
		for k,v in ipairs(monsterList) do
			if tonumber(v.id) == tonumber(tdata.monster_id) then
				enterLv = v.enter_lvl;
				break;
			end
		end

		if curMaxLv == nil or curMaxLv < enterLv then
			if enterLv <= myLv then
				curMaxLv = enterLv;
				curIdx = i;
			end
		end
	end
	local idx = curIdx;
	
	if self.needSetIdx  == true then
		idx = self.monsterIndex;
		self.needSetIdx = false;
	end
	if idx <= self.dataList:getSize() then
		self.dragList:moveToIndex(idx, true);
		self.dragList:setSelected(idx);
	end
end

function Lua_PersonalBossPanel:onRuleClick(go)
	self:superCall("onRuleClick");
	Lua_WindowUtil.openWin("Lua_RuleTipWindow",nil,LanUtil.getValue(121605));
end

function Lua_PersonalBossPanel:onGotoClick(go)
	local sceneCfg = Lua_SceneConfigData.getSceneConfig(90201);
	local myLv = DataCenter.roleData.level;
	if sceneCfg.config.monster ~= nil then
		local monsterList = sceneCfg.config.monster;
		local monsCfg = nil;
		for i,v in ipairs(monsterList) do
			if tonumber(v.id) == tonumber(self.itemData.monster_id) then
				monsCfg = v;
				break;
			end
		end
		if monsCfg ~= nil and monsCfg.enter_lvl > myLv then
			OperateAlert.show(LanUtil.getValue(121647));
			return;	
		end
	end
	local challCount = self.listData.totalChall - self.listData.leftChall;
	DataCenter.bossData:sEnterBossScene(challCount, self.listData.totalChall, self.itemData.is_live, self.itemData.monster_id, 0, 90201, true);
end

function Lua_PersonalBossPanel:OnFollowChange(val)
end