-- 洪荒仙境
checkRequire("Lua_BossBasePanel");
Lua_PrimitiveBossPanel = class("Lua_PrimitiveBossPanel", Lua_BossBasePanel)
function Lua_PrimitiveBossPanel:ctor(p)
	self:superCall("ctor", p, "PrimitiveBossPanel_skin", Lua_BossData.TYPE_PRIMITIVE_KUAFU);
end

function Lua_PrimitiveBossPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.costTxt.text = LanUtil.getValue(128606);
	self.timesTipsLab.text = LanUtil.getValue(140102);

	self.curSelectIdx = 1;
	self.listIdx = 1;
	self.firstSetIdx = true;
	self.layerDataDic = {};

	local layerNum = getConfig({"boss_base_info", "primitive_layer_val"});
	local arr = Array();
	for i = 1, layerNum.val do
		arr:add(LanUtil.formateStr(LanUtil.getValue(128632), LanUtil.getValue(100 + i)));
	end

	self.btnList = Lua_ButtonList.new(self.content, arr, 125.5, self, self.onBtnClick,
		"ui_common_btn_c2", "ui_common_btn_c1", Vector4(0, 0, 118, 53), Vector4(0, 0, 118, 53),
		Lua_ColorDefine.transColor("D2D8DC"), Lua_ColorDefine.transColor("FFFFFF"), Vector4(24, 24, 118, 30), 2, "common_atlas_1");
	self.btnList:setDepth(10);
	self.btnList:setLocation(-276, 234, 0);
	self.btnList:setSelected(1, false);

	self.gotoBtn:addClickFuntion(self, self.onGotoClick);
end

function Lua_PrimitiveBossPanel:updateDetailInfo(type)
	if type ~= self.type then
		return;
	end

	self.listData = DataCenter.bossData:getBossDetailByType(type);
	self.leftTimesTxt.text = LanUtil.formateStr(LanUtil.getValue(140103), self.listData.left_fatigued.."/"..self.listData.total_fatigued);
	self.enterTimesLab.text = LanUtil.formateStr(LanUtil.getValue(140101), tostring(self.listData.leftChall));
	
	self:clearLayerDataList();
	self.layerDataDic = {};
	for k,v in ipairs(self.listData.bossDetailSet) do
		if self.layerDataDic[tostring(v.layer)] == nil then
			self.layerDataDic[tostring(v.layer)] = Array();
		end
		self.layerDataDic[tostring(v.layer)]:add(v);
	end

	--升序排序
	for k,v in pairs(self.layerDataDic) do
		v:sort("monster_id", false);
	end

	self.dataList:clear();
	if DataCenter.bossData.checkBossId ~= nil then
		self:getMonsterIdLayer(DataCenter.bossData.checkBossId);
		self.needSetIdx = true;
		DataCenter.bossData.checkBossId = nil;
	end

	local arr = self.layerDataDic[tostring(self.curSelectIdx)]
	if arr ~= nil then
		self.dragList:setLuaArrayData(arr, false);
		local idx = 1;
		if arr:getSize() > 0 then
			idx = self.listIdx;
		end

		if self.needSetIdx then
			idx = self.monsterIndex;
			self.needSetIdx = false;
		end

		if self.firstSetIdx then
			self.dragList:moveToIndex(idx, true);
			self.dragList:setSelected(idx);
			self.firstSetIdx = false;
		end
	end
end

function Lua_PrimitiveBossPanel:clearLayerDataList()
	if self.layerDataDic ~= nil then
		while #self.layerDataDic >0 do
			self.layerDataDic[1]:clear();
			table.remove(self.layerDataDic,1);
		end
	end
end

function Lua_PrimitiveBossPanel:onListItemClick(itemData)
	self:superCall("onListItemClick",itemData);

	self.firstSetIdx = true;
	self.listIdx = self.dragList.curSelectedIdx;

	self:showInfoType(self.curCfg.monster_type);
	if self.listData.start_time ~= nil and self.listData.start_time ~= 0 and self.listData.end_time ~= nil and self.listData.end_time ~= 0 then
		self.ruleTxt:setEnable(false);
		if self.allotBtn == nil then
			self.allotBtn = UICreate.createButton(self.content, LanUtil.getValue(128637), -230, -286, 141, 22);
			self.allotBtn.txt.colorStr = Lua_ColorDefine.transColor("FFFCB7")
			self.allotBtn:setDepth(5);
			self.allotBtn:setStyle(30);
			self.allotBtn:addClickFuntion(self, self.onEnterBtnClick);
		end
		self.allotBtn:setEnable(true);
	else
		self.ruleTxt:setEnable(true);
		self.ruleTxt.text = LanUtil.formateStr(LanUtil.getValue(110654), tostring(self.listData.playerMounts[tostring(itemData.monster_id)]));
		if self.allotBtn ~= nil then
			self.allotBtn:setEnable(false);
		end
	end
end

-- type：nil，都不显示 0，小怪   1~9，采集物   大于100，boss类型
function Lua_PrimitiveBossPanel:showInfoType(type)
	if type == nil or type == 0 then
		self:showBossInfo(false);
		self:showOtherInfo(true, type);
	elseif type >= 1 and type <= 9 then
		self:showBossInfo(false);
		self:showOtherInfo(true, type);
	elseif type >= 101 then
		self:showBossInfo(true);
		self:showOtherInfo(false);
	else
		self:showBossInfo(false);
		self:showOtherInfo(false);
	end
	self:setLeftTimes(type);
end

function Lua_PrimitiveBossPanel:showBossInfo(isShow)
	if isShow then
		self.bossAtrrBtn:setAltas("boss_atlas", self.showingAttr == true and "ui_boss_icon_4" or "ui_boss_icon_2");

		self.attrTextcontainer:SetActive(self.showingAttr);
		self.rItem:setEnable(not self.showingAttr);

		self.dropTitleTxt:setEnable(true);
		self.dropTitleTxt.text = self.showingAttr == true and LanUtil.getValue(121650) or LanUtil.getValue(121649);
	else
		self.attrTextcontainer:SetActive(false);
		self.rItem:setEnable(false);
		self.dropTitleTxt:setEnable(false);
	end
	self.killRecordBg:setEnable(isShow);
	self.killRecordBtn:setEnable(isShow);
	self.bossAtrrBg:setEnable(isShow);
	self.bossAtrrBtn:setEnable(isShow);
	self.followChk:setEnable(isShow);
	self.dropTitleBg:setEnable(isShow);
end

function Lua_PrimitiveBossPanel:showOtherInfo(isShow, type)
	if isShow then
		if self.otherInfoObj == nil then
			self.otherInfoObj = UICreate.createGameObject(self.content, -47, -147, 0);
			self.otherInfoObj.name = "otherInfoObj";

			self.infoTxt1 = UICreate.createLabel(self.otherInfoObj, "", 0, 25, 428, 30, 24);
			self.infoTxt1.overflowMethod = UILabel.Overflow.ResizeFreely;
			self.infoTxt1.pivot = UIWidget.Pivot.Center;
			self.infoTxt1:setDepth(4);

			self.infoTxt2 = UICreate.createLabel(self.otherInfoObj, "", 0, -25, 428, 30, 24);
			self.infoTxt2.overflowMethod = UILabel.Overflow.ResizeFreely;
			self.infoTxt2.pivot = UIWidget.Pivot.Center;
			self.infoTxt2:setDepth(4);
		else
			self.otherInfoObj:SetActive(true);
		end

		if type == nil or type == 0 then
			self.infoTxt1.text = LanUtil.getValue(140106);
			self.infoTxt2.text = LanUtil.formateStr(LanUtil.getValue(140108), tostring(self.itemData.cur_monster_count));
		elseif type >= 1 and type <= 9 then
			self.infoTxt1.text = LanUtil.getValue(140107);
			self.infoTxt2.text = LanUtil.formateStr(LanUtil.getValue(140109), tostring(self.itemData.cur_monster_count));
		end
	else
		if self.otherInfoObj ~= nil then
			self.otherInfoObj:SetActive(false);
		end
	end
end

function Lua_PrimitiveBossPanel:setLeftTimes(type)
	if type ~= nil then
		self.monfig = getConfig( {"monster", self.itemData.monster_id});
		local curFig = getConfig( {"tv_honghuang_monster", self.itemData.monster_id});
		if curFig.hide_boss ~= nil and tonumber(curFig.hide_boss) == 1 then
			local addStr = getLanType() ~= 1 and "" or "마리";
			if tonumber(self.itemData.cur_monster_count) > 0 then
				self.remindTipsLab.text = LanUtil.getValue(140104).." " ..self.monfig.name.."[FFB319] Lv."..self.monfig.lvl.."："..self.itemData.cur_monster_count..addStr.."[-]";
			else
				self.remindTipsLab.text = LanUtil.getValue(140104).." " ..self.monfig.name.."[FFB319] Lv."..self.monfig.lvl.."：[-][FF1616]"..self.itemData.cur_monster_count..addStr.."[-]";
			end
			self.remindTipsLab:setEnable(true);
			self.killRecordBg:setEnable(false);
			self.killRecordBtn:setEnable(false);
			self.followChk:setEnable(false);
		else
			self.remindTipsLab:setEnable(false);
		end
	else
		self.remindTipsLab:setEnable(false);
	end
end

function Lua_PrimitiveBossPanel:onBtnClick(val)
	if self.curSelectIdx ~= val then
		self.listIdx = 1;
	end
	self.curSelectIdx = val;

	local tlist = self.layerDataDic[tostring(self.curSelectIdx)];
	if tlist ~= nil then
		self.dragList:setLuaArrayData(tlist, false);
		if tlist:getSize() > 0 then
			self.dragList:moveToIndex(self.listIdx, true);
			self.dragList:setSelected(self.listIdx);
		end
	end
end

function Lua_PrimitiveBossPanel:onRuleClick()
	self:superCall("onRuleClick");
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", nil, LanUtil.getValue(140105));
end

function Lua_PrimitiveBossPanel:onGotoClick()
	if self.itemData == nil then
		return;
	end
	self:checkTimes();
end

function Lua_PrimitiveBossPanel:checkTimes()
	if self.listData.leftChall <= 0 then
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = LanUtil.getValue(128623), type = 1, subFun = self.operVipWindw});
		return;
	end
	self:doSendEnterBossScene();
end

function Lua_PrimitiveBossPanel:operVipWindw()
	Lua_WindowUtil.openWin("Lua_ChongzhiWindow", WinParam.ACTION_OPEN, 10097);
	Lua_WindowUtil.openWin("Lua_MultipleServersWindow", WinParam.ACTION_CLOSE);
end

function Lua_PrimitiveBossPanel:doSendEnterBossScene()
	self:superCall("doSendEnterBossScene");

	if GlobalVar.hooking == true then
		DataCenter.hook:stop(true);
	end

	local challCount = self.listData.totalChall - self.listData.leftChall;
	local sceneCfg = Lua_SceneConfigData.getSceneConfig(tonumber(self.itemData.scene_id));
	if sceneCfg == nil or sceneCfg.config == nil then
		return;
	end

	if sceneCfg.config.tick_item ~= nil then
		local itemId = sceneCfg.config.tick_item;
		local costTicket = sceneCfg.config.tick_cost[challCount + 1];
		local leftTicket = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(itemId);
		local itemName = Lua_ToolVo.createToolVo(itemId, 1, 1).colorName;
		if costTicket ~= nil and leftTicket >= costTicket then
			Lua_WindowUtil.openWin("Lua_CopyEnterTipsWindow", WinParam.ACTION_OPEN,
				{type = sceneCfg.config.boss_copy_type, itemName = itemName, leftTicket = leftTicket, costTicket = costTicket,
				scene_id = self.itemData.scene_id, space_id = self.itemData.space_id, monster_id = self.itemData.monster_id });
			return;
		end
	end
	DataCenter.bossData:sEnterBossScene(challCount, self.listData.totalChall, self.itemData.is_live, self.itemData.monster_id, self.itemData.space_id, self.itemData.scene_id, false);
end

function Lua_PrimitiveBossPanel:onEnterBtnClick()
	local startTime = TimeTransform.getInstance():transSeconds8(self.listData.start_time, "MM-dd HH:mm");
	local endTime = TimeTransform.getInstance():transSeconds8(self.listData.end_time, "MM-dd HH:mm");
	Lua_WindowUtil.openWin("Lua_TipsWindow", WinParam.ACTION_OPEN, {owner = self, type = 2, subFun = self.onSubCallback,
		des = LanUtil.formateStr(LanUtil.getValue(140112), tostring(startTime), tostring(endTime))});
end

function Lua_PrimitiveBossPanel:onSubCallback()
end

function Lua_PrimitiveBossPanel:dispose()
	if self.allotBtn ~= nil then
		self.allotBtn:dispose();
		self.allotBtn = nil;
	end
	if self.otherInfoObj ~= nil and IsNil(self.otherInfoObj) == false then
		UnityEngine.GameObject.Destroy(self.otherInfoObj);
		self.otherInfoObj = nil;
	end
	if self.infoTxt1 ~= nil then
		self.infoTxt1:dispose();
		self.infoTxt1 = nil;
	end
	if self.infoTxt2 ~= nil then
		self.infoTxt2:dispose();
		self.infoTxt2 = nil;
	end

	self:superCall("dispose");
end