Lua_ThunderStrikeWindow = class("Lua_ThunderStrikeWindow", Lua_Window);
function Lua_ThunderStrikeWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ThunderStrikeWindow";
	self.showClose = false;
end

function Lua_ThunderStrikeWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.bg = UICreate.createImage(self.content, "/images/boss/thunder_kill.png", 0, 38, 0, 0);
	self.bg:setDepth(1);

	self.exitBtn = UICreate.createButton(self.content, LanUtil.getValue(10008), 0, -94, 192, 66);
	self.exitBtn.txt.fontSize = 28;
	self.exitBtn.txt:setLocation(0, 3, 0);
	self.exitBtn:setDepth(1);
	self.exitBtn:addClickFuntion(self, self.endCallBack);
end

function Lua_ThunderStrikeWindow:showWin(param)
	Lua_CommonUtil.removeTimer(self, self.onEnterFrame);
	if param > 0 then
		self.endTime = getTime() + param;
		Lua_CommonUtil.addTimer("thunderStrikeExitMapCD", 0.5, self, self.onEnterFrame);
	end
end

function Lua_ThunderStrikeWindow:onEnterFrame()
	if self.endTime ~= nil then
		local leftTime = math.floor(self.endTime - getTime());
		if leftTime >= 0 then
			self.exitBtn.label = LanUtil.getValue(10008) .."("..leftTime..")";
		end
	end
end

function Lua_ThunderStrikeWindow:endCallBack()
	sendMsg(10400902);
	self:hide();
end

function Lua_ThunderStrikeWindow:dispose()
	if self.bg ~= nil then
		self.bg:dispose();
		self.bg = nil;
	end
	if self.exitBtn ~= nil then
		self.exitBtn:dispose();
		self.exitBtn = nil;
	end
	Lua_CommonUtil.removeTimer(self, self.onEnterFrame);
	
	self:superCall("dispose");
end