Lua_ThurderCountWindow = class("Lua_ThurderCountWindow", Lua_Window);
function Lua_ThurderCountWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ThurderCountWindow";
	self.skinName = "ThurderCountWindow_skin";
	self.showClose = false;
	self.showBg = false;
	self.isModel = false;
end

function Lua_ThurderCountWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.imgNextNum = Lua_NumberImage.new(self.content);
	self.imgNextNum.prefix = "countDown_";
	self.imgNextNum.pivot = 2;
	self.imgNextNum.numWidth = 20;
	self.imgNextNum:setDepth(3);
	self.imgNextNum:setLocation(154, 0, 0);

	-- self.content.transform.localPosition = Vector3(0, MainWinDefine.V_height / 2 - 200, 0);
	LuaUtil.setObjPos(self.content, 0, MainWinDefine.V_height / 2 - 200, 0);
end

function Lua_ThurderCountWindow:showWin(param)
	self:superCall("showWin", param);

	Lua_CommonUtil.removeTimer(self, self.cdStep);
	if param ~= nil then
		self.endTime = getTime() + param.leftTime;		
		self:addTimer("countDownWindow_cdStep", 0.1, self, self.cdStep);
	end
end

function Lua_ThurderCountWindow:hide()
	self:finishCountDown();
	self:superCall("hide");
end

function Lua_ThurderCountWindow:finishCountDown()
	Lua_CommonUtil.removeTimer(self, self.cdStep);
	if self.showData.cbOwner ~= nil and self.showData.cbFun ~= nil then
		if self.showData.cbFunParam ~= nil then
			self.showData.cbFun(self.showData.cbOwner, self.showData.cbFunParam);
		else
			self.showData.cbFun(self.showData.cbOwner);
		end
	end
end

function Lua_ThurderCountWindow:cdStep()
	if self.endTime ~= nil then
		local leftTime = math.floor(self.endTime - getTime());
		if leftTime > 0 then
			self.imgNextNum.num = leftTime;
		else
			self:hide();
		end
	end
end