checkRequire("Lua_BossBasePanel"); -- 幽冥鬼窟
Lua_TimeLimitBossPanel = class("Lua_TimeLimitBossPanel", Lua_BossBasePanel);
function Lua_TimeLimitBossPanel:ctor(p)
	self:superCall("ctor", p, "HuangLingBossPanel_skin", Lua_BossData.TYPE_TIMELIMIT);
end

function Lua_TimeLimitBossPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.listBg:SetDimensions(333, 505);
	self.listBg:setLocation(418, 8);

	self.timeInterval = 0;
	self.listIdx = 1;
	self.firstSetIdx = true;
	self.layerDataDic = {};
	
	local btnNames = Array();
	self.cfgList = Array();
	local hlCfg = getConfig({"limit_boss_scene"});
	local showIndex = 1;
	local rlv = DataCenter.roleData.level;
	for k,v in ipairs(hlCfg) do
		btnNames:add(v.btn_name);
		if k > showIndex and rlv >= v.open_level then
			showIndex = k;
		end
		self.cfgList:add(v);
	end
	self.btnList = Lua_ButtonList.new(self.content, btnNames, 125.5, self, self.onBtnClick,
		"ui_common_btn_c2", "ui_common_btn_c1", Vector4(0, 0, 118, 53), Vector4(0, 0, 118, 53),
		Lua_ColorDefine.transColor("D2D8DC"), Lua_ColorDefine.transColor("FFFFFF"), Vector4(24, 24, 118, 30), 2, "common_atlas_1");
	self.btnList:setDepth(10);
	self.btnList:setLocation(-276, 234, 0);
	self.btnList:setSelected(showIndex, false);

	self.curSelectIdx = showIndex;
	self:setGotoBtnLabel();

	self.gotoBtn:addClickFuntion(self,self.onGotoClick);
end

function Lua_TimeLimitBossPanel:onRuleClick()
	self:superCall("onRuleClick");

	Lua_WindowUtil.openWin("Lua_RuleTipWindow",nil,LanUtil.getValue(121631));
end

function Lua_TimeLimitBossPanel:onGotoClick(go)
	local challCount = self.listData.totalChall-self.listData.leftChall;
	local hlLayerCfg = getConfig({"limit_boss_scene",self.curSelectIdx});

	if hlLayerCfg ~= nil then
		local openLevel = getConfig({"limit_boss_scene", self.curSelectIdx, "open_level"});
		if openLevel > DataCenter.roleData.level then
			local s_name = getConfig({"limit_boss_scene", self.curSelectIdx, "name"});
			OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(121671), s_name, tostring(openLevel)));
			return;
		end
		if self.listData.firstPlay == 9 then
			DataCenter.bossData:sEnterBossScene(challCount,self.listData.totalChall,self.itemData.is_live,self.itemData.monster_id,
			self.curSelectIdx,90203,false);
		else
			DataCenter.bossData:sEnterBossScene(challCount,self.listData.totalChall,self.itemData.is_live,self.itemData.monster_id,
			self.curSelectIdx,hlLayerCfg.scene_id,false);
		end
	end
end

function Lua_TimeLimitBossPanel:updateDetailInfo(type)
	if type ~= self.type then
		return;
	end

	self.listData = DataCenter.bossData:getBossDetailByType(type);
	if self.listData ~= nil then
		self.leftTimesTxt.text = LanUtil.getValue(121640)..":"..tostring(self.listData.leftChall).."/"..tostring(self.listData.totalChall);
	end
	self:setGotoBtnLabel();
	
	self:clearLayerDataList();
	self.layerDataDic = {};
	self.dataList:clear();
		
	for k,v in ipairs(self.listData.bossDetailSet) do
		if self.layerDataDic[tostring(v.layer)] == nil then
			 self.layerDataDic[tostring(v.layer)] = Array();
		end
		self.layerDataDic[tostring(v.layer)]:add(v);
	end
	
	for k,v in pairs(self.layerDataDic) do
		v:sort("lvl", false);
	end
	
	if DataCenter.bossData.checkBossId ~= nil then 
		self:getMonsterIdLayer(DataCenter.bossData.checkBossId);
		self.needSetIdx = true;
		DataCenter.bossData.checkBossId = nil;
	end
		
	local tlist = self.layerDataDic[tostring(self.curSelectIdx)];
	if tlist ~= nil then
		self.dragList:setLuaArrayData(tlist, false);
		local idx = 1;
		if tlist:getSize() > 0 then
			idx = self.listIdx;
		end

		if self.needSetIdx  == true then
			idx = self.monsterIndex;
			self.needSetIdx = false;
		end

		if self.firstSetIdx == true then
			self.dragList:moveToIndex(idx,true);
			self.dragList:setSelected(idx);
			self.firstSetIdx = false;
		end
	end
end

function Lua_TimeLimitBossPanel:clearLayerDataList()
	if self.layerDataDic ~= nil then
		while #self.layerDataDic >0 do
			self.layerDataDic[1]:clear();
			table.remove(self.layerDataDic,1);
		end
	end
end

function Lua_TimeLimitBossPanel:onListItemClick(itemData)
	self:superCall("onListItemClick",itemData);
	self.listIdx = self.dragList.curSelectedIdx;
	self.ruleTxt.text = LanUtil.formateStr(LanUtil.getValue(110654), tostring(self.listData.playerMounts[tostring(itemData.monster_id)]));
end

function Lua_TimeLimitBossPanel:onBtnClick(val)
	if self.firstSetIdx == false then
		local openLevel = getConfig({"limit_boss_scene", val, "open_level"});
		if openLevel > DataCenter.roleData.level and getTime() - self.timeInterval > 1 then
			self.timeInterval = getTime();
			local s_name = getConfig({"limit_boss_scene", val, "name"});
			OperateAlert.show(LanUtil.formateStr(LanUtil.getValue(121671), s_name, tostring(openLevel)));
		end
	end

	if self.curSelectIdx ~= val then
		self.listIdx = 1;
	end
	self.curSelectIdx = val;
	self:setGotoBtnLabel();
	
	local tlist = self.layerDataDic[tostring(self.curSelectIdx)]
	if tlist ~= nil then
		self.dragList:setLuaArrayData(tlist, false);
		if tlist:getSize() > 0 then
			self.dragList:moveToIndex(self.listIdx,true);
			self.dragList:setSelected(self.listIdx);
		end
	end
end

function Lua_TimeLimitBossPanel:setGotoBtnLabel()
	--不关联vip 2018.2.26策划需求
	-- local timeBossCfg = self.cfgList[self.curSelectIdx];
	-- local needVip = timeBossCfg.vip_limit;
	-- self.gotoBtn.label = LanUtil.formateStr(LanUtil.getValue(121636),tostring(needVip));

	if self.listData == nil then
		return;
	end

	local timeBossCfg = self.cfgList[self.curSelectIdx];
	if timeBossCfg.scene_id ~= nil then
		local sceneCfg = Lua_SceneConfigData.getSceneConfig(timeBossCfg.scene_id);
		if sceneCfg.config.tick_item ~= nil then
			local toolVo = Lua_ToolVo.createToolVo(sceneCfg.config.tick_item);
			local itemNum = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK):getItemNum(sceneCfg.config.tick_item);
			self.costTxt.text = LanUtil.formateStr(LanUtil.getValue(121642),toolVo.name)..tostring(itemNum).."/"..tostring(self.listData.costTicket);
		end
	else
		self.costTxt.text  = "";
	end
end

-- 用于图鉴功能--通过bossID 让光标移到对应boss
function Lua_TimeLimitBossPanel:getMonsterIdLayer(monsterId)
	local list =self.listData.bossDetailSet;
	if list == nil then
		return;
	end

	for k,v in ipairs(list) do
		if v.monster_id == monsterId then
			self.monsterLayer = v.layer;
			break;
		end
	end

	local arr =  self.layerDataDic[tostring(self.monsterLayer)];
	for i=1,arr:getSize() do
		if arr[i].monster_id == monsterId then
			self.monsterIndex = i;
			self.monsterLayer = arr[i].layer;
			break;
		end
	end
	self:onBtnClick(self.monsterLayer);
	self.btnList:setSelected(self.monsterLayer, false)
end