-- 世界BOSS
checkRequire("Lua_BossBasePanel");
Lua_WildBossPanel = class("Lua_WildBossPanel", Lua_BossBasePanel);
function Lua_WildBossPanel:ctor(p)
	self:superCall("ctor", p, "PersonalBossPanel_skin", Lua_BossData.TYPE_WILD);
end

function Lua_WildBossPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.gotoBtn.label = LanUtil.getValue(110917);
	self.costTxt:setEnable(false);
	self.firstSetIdx = true;

	self.gotoBtn:addClickFuntion(self, self.onGotoClick);
end

function Lua_WildBossPanel:onGotoClick()
	if self.itemData == nil then
		return;
	end

	if self.listData.firstPlay == 7 or self.listData.firstPlay == 9 then
		local cmd = getProtoMsg("Proto10401601");
		if self.listData.firstPlay == 7 then 
			cmd.scene_id = tonumber(90202);
		else
			cmd.scene_id = tonumber(90203);
		end
		cmd.space_id = 0;
		cmd.monster_id = 0
		sendMsg(10401601, cmd);
		return;
	end

	if DataCenter.roleData.level- self.itemData.lvl > self.curCfg.limit_level then
		local tipData = {};
		tipData.des = LanUtil.formateStr(LanUtil.getValue(121634), tostring(self.curCfg.limit_level));
		tipData.owner = self;
		tipData.type = 1;
		tipData.subFun = self.checkTimes;
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
		return;
	end	
	self:checkTimes();
end

function Lua_WildBossPanel:checkTimes()
	if self.listData.leftChall <= 0 then
		local tipData = {};
		tipData.des = LanUtil.getValue(121645)
		tipData.owner = self;
		tipData.type = 1;
		tipData.subFun = self.doSendEnterBossScene;
		Lua_WindowUtil.openWin("Lua_TipsWindow", nil, tipData);
		return;
	end
	self:doSendEnterBossScene();
end

function Lua_WildBossPanel:doSendEnterBossScene()
	self:superCall("doSendEnterBossScene");
	
	if GlobalVar.hooking == true then
		DataCenter.hook:stop(true);
	end
	local challCount = self.listData.totalChall - self.listData.leftChall;
	DataCenter.bossData:sEnterBossScene(challCount, self.listData.totalChall, self.itemData.is_live,
		self.itemData.monster_id, self.itemData.space_id,self.itemData.scene_id,false);
end

function Lua_WildBossPanel:updateDetailInfo(type)
	self:superCall("updateDetailInfo", type);

	if self.firstSetIdx  == true then
		local myLv = DataCenter.roleData.level;
		local len = self.dataList:getSize();
		local curMinIdx = 1;
		local curMinLevel  = nil;
		for i = 1, len do
			if curMinLevel == nil or math.abs(myLv - self.dataList[i].lvl) < curMinLevel then
				curMinLevel = math.abs(myLv - self.dataList[i].lvl);
				curMinIdx =i;
			end
			
		end

		if self.needSetIdx  == true then
			curMinIdx = self.monsterIndex;
		end
		self.dragList:moveToIndex(curMinIdx, true);
		self.dragList:setSelected(curMinIdx);
		self.firstSetIdx = false;
	end

	if self.listData ~= nil then		
		self.leftTimesTxt.text = LanUtil.getValue(121608)..":"..tostring(self.listData.totalChall-self.listData.leftChall).."/"..tostring(self.listData.totalChall);
	end
end

function Lua_WildBossPanel:onRuleClick()
	self:superCall("onRuleClick");

	Lua_WindowUtil.openWin("Lua_RuleTipWindow", nil, LanUtil.getValue(121629));
end